
var contents = [
	{ name: "Introduction", src: "introduction.html" },
	{ name: "Terminology", src: "terminology.html" },
	{ name: "User Interface", src: "userinterface.html", items: [
		{ name: "About the User Interface", src: "userinterface.html" },
		{ name: "Main Window", src: "w_mainwindow.html" },
		{ name: "Custom Fields Editor", src: "w_customfields.html" },
		{ name: "Errors and Warnings Window", src: "w_errorsandwarnings.html" },
		{ name: "Game Configurations Window", src: "w_gameconfigurations.html" },
		{ name: "Grid Setup Window", src: "w_gridsetup.html" },
		{ name: "Image Browser Window", src: "w_imagesbrowser.html" },
		{ name: "Linedef Properties Window", src: "w_linedefedit.html" },
		{ name: "Map Options Window", src: "w_mapoptions.html" },
		{ name: "Open Map Window", src: "w_openmapoptions.html" },
		{ name: "Preferences Window", src: "w_preferences.html" },
		{ name: "Resource Options Window", src: "w_resourceoptions.html" },
		{ name: "Script Editor Window", src: "w_scripteditor.html" },
		{ name: "Sector Properties Window", src: "w_sectoredit.html" },
		{ name: "Texture Sets Window", src: "w_textureset.html" },
		{ name: "Thing Properties Window", src: "w_thingedit.html" },
		{ name: "Things Filters Window", src: "w_thingsfilters.html" },
		{ name: "Vertex Properties Window", src: "w_vertexedit.html" }
	]},
	{ name: "Editing Modes", src: "editingmodes.html", items: [
		{ name: "About Editing Modes", src: "editingmodes.html" },
		{ name: "Curve Linedefs Mode", src: "e_curvelinedefs.html" },
		{ name: "Draw Geometry Mode", src: "e_drawgeometry.html" },
		{ name: "Edit Selection Mode", src: "e_editselection.html" },
		{ name: "Find & Replace Mode", src: "e_findreplace.html" },
		{ name: "Linedefs Mode", src: "e_linedefs.html" },
		{ name: "Make Sectors Mode", src: "e_makesectors.html" },
		{ name: "Map Analysis Mode", src: "e_mapanalysis.html" },
		{ name: "Sectors Mode", src: "e_sectors.html" },
		{ name: "Things Mode", src: "e_things.html" },
		{ name: "Vertices Mode", src: "e_vertices.html" },
		{ name: "Visual Mode", src: "e_visual.html" }
	]},
	{ name: "Configurations", src: "configurations.html", items: [
		{ name: "About Configurations", src: "configurations.html" },
		{ name: "Configuration Syntax", src: "configstructure.html" },
		{ name: "Compiler Configurations", src: "compilerconfigs.html", items: [
			{ name: "About Compiler Configurations", src: "compilerconfigs.html" }
		]},
		{ name: "Game Configurations", src: "gameconfigs.html", items: [
			{ name: "About Game Configurations", src: "gameconfigs.html" },
			{ name: "Basic Settings", src: "gc_basicsettings.html" },
			{ name: "Map Format Settings", src: "gc_formatsettings.html" },
			{ name: "Resource Settings", src: "gc_resourcesettings.html" },
			{ name: "Sectors Settings", src: "gc_sectorsettings.html" },
			{ name: "Linedefs Settings", src: "gc_linedefsettings.html" },
			{ name: "Sidedef Settings", src: "gc_sidedefsettings.html" },
			{ name: "Things Settings", src: "gc_thingsettings.html" },
			{ name: "Action Argument Settings", src: "gc_argumentsettings.html" }
		]},
		{ name: "Scripting Configurations", src: "scriptingconfigs.html", items: [
			{ name: "About Scripting Configurations", src: "scriptingconfigs.html" }
		]},
		{ name: "DECORATE keys", src: "gc_decoratekeys.html" }
	]},
	{ name: "Ultimate Doom Builder manual", src: "gz_introduction.html", items: [
		{ name: "Features", src: "gzdb/features/features.html", items: [
			{ name: "General Interface", src: "gzdb/features/features.html#general", items: [
				{ name: "Rendering toolbar", src: "gzdb/features/general/rendering_toolbar.html" },
				{ name: "Multiple engines per game configuration", src: "gzdb/features/general/multi_engines.html" }
			]},
			{ name: "Scripting", src: "gzdb/features/features.html#scripting", items: [
				{ name: "Enhanced scripting workflow", src: "gzdb/features/scripting/acs.html" },
				{ name: "Code Snippets", src: "gzdb/features/scripting/snippets.html" }
			]},
			{ name: "New features in Classic and Visual modes", src: "gzdb/features/features.html#allmodes", items: [
				{ name: "Enhanced Tag support", src: "gzdb/features/all_modes/tag_support.html" },
				{ name: "Event lines", src: "gzdb/features/all_modes/event_lines.html" },
				{ name: "Testing map from view", src: "gzdb/features/all_modes/test_from_view.html" },
				{ name: "Synchronizing selection", src: "gzdb/features/all_modes/synch_selection.html" },
				{ name: "Synchronizing camera position", src: "gzdb/features/all_modes/synch_camera.html" },
				{ name: "Color Picker plugin", src: "gzdb/features/all_modes/colorpicker.html" },
				{ name: "Tag Explorer plugin", src: "gzdb/features/all_modes/tagexplorer.html" },
				{ name: "Image Browser", src: "gzdb/features/all_modes/texture_browser.html" }
			]},
			{ name: "New features in Classic modes", src: "gzdb/features/features.html#classic", items: [
				{ name: "Draw Settings Panel", src: "gzdb/features/classic_modes/drawsettingspanel.html" },
				{ name: "Custom linedef colors", src: "gzdb/features/classic_modes/linedef_color_presets.html" },
				{ name: "Enhanced rectangular selection", src: "gzdb/features/classic_modes/selection.html" }
			]},
			{ name: "New features in Sectors mode", src: "gzdb/features/features.html#sectors" },
			{ name: "New features in Linedefs mode", src: "gzdb/features/features.html#linedefs" },
			{ name: "Draw Rectangle mode", src: "gzdb/features/classic_modes/mode_drawrect.html" },
			{ name: "Draw Ellipse mode", src: "gzdb/features/classic_modes/mode_drawellipse.html" },
			{ name: "Draw Curve mode", src: "gzdb/features/classic_modes/mode_drawcurve.html" },
			{ name: "Draw Grid mode", src: "gzdb/features/classic_modes/mode_drawgrid.html" },
			{ name: "Sound Propagation Mode", src: "gzdb/features/classic_modes/mode_soundpropagation.html" },
			{ name: "Sound Environment Mode", src: "gzdb/features/classic_modes/mode_soundenvironment.html" },
			{ name: "3D Floor Mode", src: "gzdb/features/classic_modes/mode_3dfloor.html" },
			{ name: "Draw Slope Mode/Slope Mode", src: "gzdb/features/classic_modes/mode_slopes.html" },
			{ name: "Randomize mode", src: "gzdb/features/all_modes/jitter.html" },
			{ name: "Bridge mode", src: "gzdb/features/classic_modes/mode_drawbridge.html" },
			{ name: "Import Terrain mode", src: "gzdb/features/classic_modes/mode_importterrain.html" },
			{ name: "Snap geometry mode", src: "gzdb/features/classic_modes/mode_snapelements.html" },
			{ name: "New features in Things mode", src: "gzdb/features/features.html#things", items: [
				{ name: "Assigning multiple thing types at once", src: "gzdb/features/things_mode/multiple_thing_types.html" },
				{ name: "\"Point Thing to Cursor\" action", src: "gzdb/features/things_mode/pointthing.html" }
			]},
			{ name: "New features in Vertices mode", src: "gzdb/features/features.html#vertices" },
			{ name: "GZDB Visual mode", src: "gzdb/features/features.html#visual", items: [
				{ name: "Visual vertices (UDMF)", src: "gzdb/features/visual_mode/visual_verts.html" },
				{ name: "Using Auto Align Textures actions on floors and ceilings (UDMF)", src: "gzdb/features/visual_mode/autoalignfloors.html" },
				{ name: "\"Fit Texture\" actions", src: "gzdb/features/visual_mode/texturefit.html" },
				{ name: "\"Auto-align Textures to Selection\" actions", src: "gzdb/features/visual_mode/autoalign_to_selection.html" }
			]},
			{ name: "New features in Map Analysis mode", src: "gzdb/features/features.html#mapanalysis" },
			{ name: "New features in Find and Replace mode", src: "gzdb/features/features.html#findreplace" },
			{ name: "Custom Fields", src: "gzdb/features/features.html#fields", items: [
				{ name: "New custom field types", src: "gzdb/features/custom_fields/newfieldtypes.html" }
			]},
			{ name: "(G)ZDoom features support", src: "gzdb/features/features.html#formats" }
		]},
		{ name: "(G)ZDoom text lumps support", src: "gzdb/text_lumps.html" },
		{ name: "List of deprecated plugins", src: "gzdb/deprecated_plugins.html" },
		{ name: "Compiling GZDoom Builder", src: "gzdb/compilingtheeditor.html" }
	]},
	{ name: "Frequently asked questions", src: "gzdb/faq.html" },
	{ name: "Command Line Parameters", src: "commandlineparams.html" },
	{ name: "System Requirements", src: "systemrequirements.html" }
];

var searchbox = document.getElementById("searchbox");
var listview = document.getElementById("listview");
var content = document.getElementById("content");
var listviewItems = [];

// note: generated by the generateIndex() function and then pasted into this file
var searchIndex = {"items":[{"name":"Introduction","src":"introduction.html"},{"name":"Terminology","src":"terminology.html"},{"name":"User Interface","src":"userinterface.html"},{"name":"About the User Interface","src":"userinterface.html"},{"name":"Main Window","src":"w_mainwindow.html"},{"name":"Custom Fields Editor","src":"w_customfields.html"},{"name":"Errors and Warnings Window","src":"w_errorsandwarnings.html"},{"name":"Game Configurations Window","src":"w_gameconfigurations.html"},{"name":"Grid Setup Window","src":"w_gridsetup.html"},{"name":"Image Browser Window","src":"w_imagesbrowser.html"},{"name":"Linedef Properties Window","src":"w_linedefedit.html"},{"name":"Map Options Window","src":"w_mapoptions.html"},{"name":"Open Map Window","src":"w_openmapoptions.html"},{"name":"Preferences Window","src":"w_preferences.html"},{"name":"Resource Options Window","src":"w_resourceoptions.html"},{"name":"Script Editor Window","src":"w_scripteditor.html"},{"name":"Sector Properties Window","src":"w_sectoredit.html"},{"name":"Texture Sets Window","src":"w_textureset.html"},{"name":"Thing Properties Window","src":"w_thingedit.html"},{"name":"Things Filters Window","src":"w_thingsfilters.html"},{"name":"Vertex Properties Window","src":"w_vertexedit.html"},{"name":"Editing Modes","src":"editingmodes.html"},{"name":"About Editing Modes","src":"editingmodes.html"},{"name":"Curve Linedefs Mode","src":"e_curvelinedefs.html"},{"name":"Draw Geometry Mode","src":"e_drawgeometry.html"},{"name":"Edit Selection Mode","src":"e_editselection.html"},{"name":"Find & Replace Mode","src":"e_findreplace.html"},{"name":"Linedefs Mode","src":"e_linedefs.html"},{"name":"Make Sectors Mode","src":"e_makesectors.html"},{"name":"Map Analysis Mode","src":"e_mapanalysis.html"},{"name":"Sectors Mode","src":"e_sectors.html"},{"name":"Things Mode","src":"e_things.html"},{"name":"Vertices Mode","src":"e_vertices.html"},{"name":"Visual Mode","src":"e_visual.html"},{"name":"Configurations","src":"configurations.html"},{"name":"About Configurations","src":"configurations.html"},{"name":"Configuration Syntax","src":"configstructure.html"},{"name":"Compiler Configurations","src":"compilerconfigs.html"},{"name":"About Compiler Configurations","src":"compilerconfigs.html"},{"name":"Game Configurations","src":"gameconfigs.html"},{"name":"About Game Configurations","src":"gameconfigs.html"},{"name":"Basic Settings","src":"gc_basicsettings.html"},{"name":"Map Format Settings","src":"gc_formatsettings.html"},{"name":"Resource Settings","src":"gc_resourcesettings.html"},{"name":"Sectors Settings","src":"gc_sectorsettings.html"},{"name":"Linedefs Settings","src":"gc_linedefsettings.html"},{"name":"Sidedef Settings","src":"gc_sidedefsettings.html"},{"name":"Things Settings","src":"gc_thingsettings.html"},{"name":"Action Argument Settings","src":"gc_argumentsettings.html"},{"name":"Scripting Configurations","src":"scriptingconfigs.html"},{"name":"About Scripting Configurations","src":"scriptingconfigs.html"},{"name":"DECORATE keys","src":"gc_decoratekeys.html"},{"name":"Ultimate Doom Builder manual","src":"gz_introduction.html"},{"name":"Features","src":"gzdb/features/features.html"},{"name":"General Interface","src":"gzdb/features/features.html#general"},{"name":"Rendering toolbar","src":"gzdb/features/general/rendering_toolbar.html"},{"name":"Multiple engines per game configuration","src":"gzdb/features/general/multi_engines.html"},{"name":"Scripting","src":"gzdb/features/features.html#scripting"},{"name":"Enhanced scripting workflow","src":"gzdb/features/scripting/acs.html"},{"name":"Code Snippets","src":"gzdb/features/scripting/snippets.html"},{"name":"New features in Classic and Visual modes","src":"gzdb/features/features.html#allmodes"},{"name":"Enhanced Tag support","src":"gzdb/features/all_modes/tag_support.html"},{"name":"Event lines","src":"gzdb/features/all_modes/event_lines.html"},{"name":"Testing map from view","src":"gzdb/features/all_modes/test_from_view.html"},{"name":"Synchronizing selection","src":"gzdb/features/all_modes/synch_selection.html"},{"name":"Synchronizing camera position","src":"gzdb/features/all_modes/synch_camera.html"},{"name":"Color Picker plugin","src":"gzdb/features/all_modes/colorpicker.html"},{"name":"Tag Explorer plugin","src":"gzdb/features/all_modes/tagexplorer.html"},{"name":"Image Browser","src":"gzdb/features/all_modes/texture_browser.html"},{"name":"New features in Classic modes","src":"gzdb/features/features.html#classic"},{"name":"Draw Settings Panel","src":"gzdb/features/classic_modes/drawsettingspanel.html"},{"name":"Custom linedef colors","src":"gzdb/features/classic_modes/linedef_color_presets.html"},{"name":"Enhanced rectangular selection","src":"gzdb/features/classic_modes/selection.html"},{"name":"New features in Sectors mode","src":"gzdb/features/features.html#sectors"},{"name":"New features in Linedefs mode","src":"gzdb/features/features.html#linedefs"},{"name":"Draw Rectangle mode","src":"gzdb/features/classic_modes/mode_drawrect.html"},{"name":"Draw Ellipse mode","src":"gzdb/features/classic_modes/mode_drawellipse.html"},{"name":"Draw Curve mode","src":"gzdb/features/classic_modes/mode_drawcurve.html"},{"name":"Draw Grid mode","src":"gzdb/features/classic_modes/mode_drawgrid.html"},{"name":"Sound Propagation Mode","src":"gzdb/features/classic_modes/mode_soundpropagation.html"},{"name":"Sound Environment Mode","src":"gzdb/features/classic_modes/mode_soundenvironment.html"},{"name":"3D Floor Mode","src":"gzdb/features/classic_modes/mode_3dfloor.html"},{"name":"Draw Slope Mode/Slope Mode","src":"gzdb/features/classic_modes/mode_slopes.html"},{"name":"Randomize mode","src":"gzdb/features/all_modes/jitter.html"},{"name":"Bridge mode","src":"gzdb/features/classic_modes/mode_drawbridge.html"},{"name":"Import Terrain mode","src":"gzdb/features/classic_modes/mode_importterrain.html"},{"name":"Snap geometry mode","src":"gzdb/features/classic_modes/mode_snapelements.html"},{"name":"New features in Things mode","src":"gzdb/features/features.html#things"},{"name":"Assigning multiple thing types at once","src":"gzdb/features/things_mode/multiple_thing_types.html"},{"name":"\"Point Thing to Cursor\" action","src":"gzdb/features/things_mode/pointthing.html"},{"name":"New features in Vertices mode","src":"gzdb/features/features.html#vertices"},{"name":"GZDB Visual mode","src":"gzdb/features/features.html#visual"},{"name":"Visual vertices (UDMF)","src":"gzdb/features/visual_mode/visual_verts.html"},{"name":"Using Auto Align Textures actions on floors and ceilings (UDMF)","src":"gzdb/features/visual_mode/autoalignfloors.html"},{"name":"\"Fit Texture\" actions","src":"gzdb/features/visual_mode/texturefit.html"},{"name":"\"Auto-align Textures to Selection\" actions","src":"gzdb/features/visual_mode/autoalign_to_selection.html"},{"name":"New features in Map Analysis mode","src":"gzdb/features/features.html#mapanalysis"},{"name":"New features in Find and Replace mode","src":"gzdb/features/features.html#findreplace"},{"name":"Custom Fields","src":"gzdb/features/features.html#fields"},{"name":"New custom field types","src":"gzdb/features/custom_fields/newfieldtypes.html"},{"name":"(G)ZDoom features support","src":"gzdb/features/features.html#formats"},{"name":"(G)ZDoom text lumps support","src":"gzdb/text_lumps.html"},{"name":"List of deprecated plugins","src":"gzdb/deprecated_plugins.html"},{"name":"Compiling GZDoom Builder","src":"gzdb/compilingtheeditor.html"},{"name":"Frequently asked questions","src":"gzdb/faq.html"},{"name":"Command Line Parameters","src":"commandlineparams.html"},{"name":"System Requirements","src":"systemrequirements.html"}],"keys":{"0":[13,33,36,41,42,43,44,45,47,48,49,50,51,53,57,60,69,73,85,87,90,96,100,103,106],"1":[11,13,27,33,36,41,42,43,44,45,47,48,49,50,51,53,57,58,60,61,62,69,73,85,87,90,92,93,96,99,100,102],"2":[0,11,13,27,36,41,42,44,45,47,48,49,50,51,52,53,57,60,61,62,69,73,87,90,92,93,96,100,101,102,103,105,106],"3":[7,11,14,36,41,42,44,47,48,49,50,51,52,53,57,60,62,69,73,87,90,93,96,100,102,103,106],"4":[36,41,42,44,45,47,48,51,106],"5":[41,42,43,44,47,48,51,53,57,60,69,73,87,90,96,100,103,106],"6":[42,47,49,50,51],"7":[42,44,47,51,103,106],"8":[7,30,33,36,41,42,44,45,47,48,51,53,57,60,69,73,87,90,96,100,106],"9":[42,44,47,51,67,106],"10":[42,44,47,48,51,61,106],"11":[42,47,48,51,106],"12":[42,47,48,51,67],"13":[42,47,48,51],"14":[42,47,48,51,102],"15":[13,42,47,48,51],"16":[42,45,47,48,51,53,57,60,69,73,87,90,96,100],"17":[42,47,51],"18":[47,49,50,51],"19":[47,51],"20":[44,47],"22":[42,48],"23":[48,51],"24":[48,51],"25":[48],"26":[48,51],"30":[36,51,92],"32":[13,44,45,47,51,53,57,60,69,73,87,90,96,100],"35":[49,50],"40":[36],"44":[51],"45":[25,41],"55":[36],"64":[8,44,45,51,53,57,60,69,73,87,90,96,100],"68":[13],"96":[44],"118":[53,57,60,69,73,87,90,96,100],"123":[99],"128":[44,53,57,60,69,73,82,87,90,96,100],"138":[36],"181":[71,93],"255":[48],"256":[44],"512":[44,45,51],"667":[51],"1024":[45],"1504":[85],"2008":[103,106],"2048":[45],"3001":[47,101],"3072":[45],"4096":[45],"5104":[51],"5120":[45],"6812":[103],"7012":[52],"8192":[45,47],"9038":[48],"9998":[47],"16384":[47],"21138":[103],"32392":[52],"32767":[41],"32768":[41],"introduction":[0,52],"doom":[0,1,2,3,4,7,8,10,11,12,13,14,17,21,22,34,35,36,39,40,41,42,43,44,45,47,51,52,53,57,60,61,69,73,87,90,96,100,101,102,105],"builder":[0,1,2,3,4,10,11,12,13,14,17,21,22,34,35,36,39,40,41,42,43,44,45,47,51,52,53,57,58,60,61,69,73,87,90,96,100,101,102,103,104,105,106],"is":[0,1,4,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,47,48,49,50,51,52,53,57,58,59,60,61,63,64,65,66,67,68,69,71,72,73,75,76,77,79,80,81,82,84,85,87,90,92,93,96,99,100,101,102,103,104,105],"an":[0,1,4,7,8,9,11,13,18,30,33,36,37,38,41,43,47,48,49,50,51,52,61,65,67,72,81,99,103],"advanced":[0,7,10,25,34,35],"revolutionary":[0],"map":[0,1,2,3,5,6,7,8,11,12,13,15,17,23,24,25,26,27,28,29,30,31,32,33,39,40,41,42,45,47,51,52,53,56,57,60,61,63,65,67,69,70,72,73,79,80,86,87,90,92,96,99,100,101,102,104,105],"editor":[0,5,7,10,13,15,16,18,19,20,24,34,35,36,37,38,41,42,48,49,50,51,52,53,57,58,59,60,69,70,73,87,90,96,100,101,103,105],"for":[0,1,2,3,5,7,9,10,11,12,13,14,15,16,17,18,19,20,21,22,26,29,30,33,34,35,36,37,38,39,40,41,42,43,44,45,47,48,49,50,51,52,53,56,57,59,60,61,62,68,69,73,81,82,83,87,90,92,93,96,99,100,101,102,103,104,105],"and":[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,21,22,23,24,25,26,27,28,29,30,31,32,33,36,37,38,39,40,41,42,43,44,45,47,48,49,50,51,52,53,57,58,59,60,61,62,64,65,66,67,68,69,70,71,72,73,75,76,77,78,80,81,82,83,84,87,88,89,90,92,93,95,96,99,100,101,102,103,104,105],"games":[0,52,101,105],"based":[0,41,52,75,76,79,80,93],"on":[0,1,2,3,4,5,7,8,9,10,13,14,16,17,18,19,20,21,22,24,25,26,27,29,30,33,36,41,43,44,45,46,47,49,50,51,52,53,56,57,60,61,62,69,71,73,75,76,77,79,80,81,82,83,87,90,93,95,96,100,103,104,105],"the":[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,75,76,77,78,79,80,81,82,84,85,86,87,88,89,90,92,93,94,96,99,100,101,102,103,104,105,106],"engine":[0,1,36,41,52,56],"such":[0,6,7,10,13,15,24,31,36,51,52,53,57,60,69,73,87,90,96,100,105],"as":[0,1,6,7,8,10,11,12,13,14,15,18,24,30,31,33,34,35,36,39,40,41,44,47,48,49,50,51,52,53,57,58,60,61,63,66,68,69,73,81,85,87,90,93,94,96,99,100,101,104,105],"heretic":[0,41,43],"hexen":[0,1,10,15,18,41,42,81],"strife":[0,41,102],"this":[0,1,2,3,4,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,23,24,25,26,27,28,29,30,31,32,33,34,35,36,39,40,41,42,43,44,45,47,48,49,50,51,52,53,57,60,61,63,64,65,66,67,68,69,70,71,72,73,75,76,77,78,79,80,81,82,83,84,85,86,87,89,90,92,94,96,99,100,101,103,104,105],"highly":[0],"extendible":[0],"different":[0,10,11,13,14,16,18,20,21,22,33,34,35,39,40,41,47,51,65,66,83,84],"game":[0,1,5,7,9,10,11,12,13,17,18,19,33,36,37,38,39,40,41,42,43,44,45,46,47,48,51,53,56,57,60,63,68,69,73,87,90,96,100,101,104,105],"engines":[0,53,56,57,60,69,73,87,90,96,100],"of":[0,1,2,3,4,5,7,8,9,10,11,12,13,14,15,16,17,18,19,20,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,47,48,49,50,51,52,53,55,57,59,60,61,62,66,67,68,69,71,72,73,76,78,81,82,83,84,85,87,90,92,93,94,95,96,99,100,101,102,103,104,105],"community":[0],"introduced":[0],"3d":[0,13,33,52,53,57,60,65,69,73,81,82,84,85,87,90,93,96,100],"editing":[0,1,2,3,4,7,11,12,13,15,17,21,22,23,24,25,27,28,30,31,32,33,39,40,53,57,60,64,69,72,73,75,76,77,78,81,82,87,90,96,100,102],"mode":[0,13,21,22,23,24,25,26,27,28,29,30,31,32,33,41,47,51,52,53,55,57,60,61,63,64,65,66,69,72,73,75,76,77,78,79,80,81,82,83,84,85,86,87,89,90,92,93,94,96,100,101,102,103,104,105],"in":[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,47,48,49,50,51,52,53,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,71,72,73,78,80,81,82,83,84,85,87,88,89,90,92,93,94,96,99,100,101,102,103,104,105],"still":[0,23,41,53,57,60,69,73,79,87,90,96,100,106],"leading":[0],"levels":[0,30,41,44],"today":[0],"reference":[0,2,3,34,35,52,53,57,60,69,73,87,90,96,100,103],"manual":[0,2,3,34,35,52,53,57,60,69,73,87,90,96,100],"you":[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,45,47,51,52,53,55,57,58,59,60,61,63,64,65,66,67,68,69,70,71,72,73,75,76,77,78,80,81,82,83,84,85,87,88,89,90,92,93,94,95,96,100,101,103,104,105,106],"can":[0,1,4,5,6,7,8,9,10,11,12,13,14,16,17,18,19,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,44,45,46,47,48,51,52,53,55,56,57,58,59,60,61,62,64,65,66,68,69,70,71,72,73,75,76,77,78,79,80,81,82,83,84,85,87,88,89,90,92,93,96,100,101,102,103,104,105],"use":[0,1,7,9,11,12,13,14,16,17,18,19,21,22,23,24,26,28,29,30,31,36,37,38,39,40,41,42,43,44,45,47,48,49,50,51,52,53,56,57,59,60,61,63,69,70,72,73,75,76,77,78,81,82,83,84,85,87,90,92,95,96,99,100,101,103,104,105],"to":[0,1,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,47,48,49,50,51,52,53,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,92,93,94,95,96,99,100,101,102,103,104,105,106],"look":[0,9,13,33,36,52,53,57,60,69,73,87,90,96,100],"up":[0,2,3,4,15,17,19,23,27,33,39,40,42,51,52,61,66,80,81,82,85,101,105],"how":[0,1,7,8,11,13,14,17,34,35,36,45,52,63,65,77,79,84,101,104],"works":[0,7,33,41,45,53,57,60,61,63,65,69,73,81,82,87,90,93,96,100],"what":[0,7,12,17,21,22,36,37,38,42,47,49,50,52,82,104],"specific":[0,1,4,7,10,19,21,22,24,26,31,36,37,38,39,40,41,47,52,53,57,60,69,73,87,90,96,100],"modes":[0,7,13,21,22,23,24,25,27,28,30,31,32,33,47,48,51,52,53,57,60,62,64,65,69,71,72,73,79,80,83,84,87,90,94,95,96,100],"actions":[0,4,8,10,13,16,33,39,40,41,45,52,53,55,57,60,67,69,73,75,76,77,78,81,84,87,90,93,95,96,100,101,105],"do":[0,1,7,10,11,12,14,15,21,22,24,25,34,35,36,37,38,42,43,45,49,50,52,53,57,60,64,69,73,80,82,84,87,88,90,96,100,102,103,105],"not":[0,1,5,6,7,10,11,12,13,14,15,17,19,24,33,34,35,36,37,38,39,40,41,42,43,45,48,51,52,53,57,59,60,61,69,73,79,80,81,82,85,87,90,96,100,102,104,105,106],"a":[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,57,58,59,60,61,63,65,66,67,68,69,71,72,73,77,79,80,81,82,83,84,85,87,88,90,92,93,94,95,96,99,100,101,102,103,104,105],"beginners":[0,52],"tutorial":[0,52],"that":[0,1,4,5,7,8,9,10,11,12,13,14,15,16,17,18,19,23,24,25,26,27,29,30,31,32,33,34,35,36,39,40,41,42,43,44,45,46,47,48,51,52,53,57,59,60,61,63,64,65,69,70,72,73,80,81,82,87,90,93,96,100,101,103,105],"teaches":[0,52],"make":[0,7,9,10,13,17,23,27,28,30,36,41,42,52,53,57,60,69,73,80,81,82,84,87,90,96,100,103],"maps":[0,1,11,12,14,41,52,53,57,60,69,73,80,87,90,96,100,101,105],"gzdoom":[0,13,41,51,52,53,57,58,60,69,73,87,90,96,100,101,102,103,104,105,106],"available":[0,9,10,13,16,18,20,24,39,40,41,43,44,53,57,60,69,73,81,82,87,90,93,96,100],"here":[0,7,10,11,36,37,38,39,40,52,63,65,99,104],"terminology":[1],"resource":[1,7,9,11,12,14,43,68,101,104,105],"file":[1,4,7,8,11,12,13,14,15,36,37,38,39,40,41,47,49,50,51,53,57,59,60,69,73,85,87,90,96,100,101,103,105],"or":[1,4,6,7,8,9,10,11,13,14,16,17,18,19,20,23,24,25,26,27,28,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,47,48,49,50,51,52,53,55,57,58,59,60,61,62,66,67,69,70,73,75,76,77,78,80,81,82,83,84,85,87,90,92,93,96,100,101,102,103,104,105,106],"directory":[1,14,34,35,37,38,39,40,41,47,49,50,51,53,57,60,68,69,73,87,90,96,100,103,105],"from":[1,6,7,8,10,11,12,13,14,15,18,19,23,24,25,26,27,28,30,31,32,33,36,37,38,39,40,41,42,43,44,45,47,49,50,51,52,53,57,59,60,61,63,64,65,69,70,71,73,79,81,82,83,85,87,88,89,90,92,93,96,99,100,101,102,103,104,105],"which":[1,2,3,7,9,10,11,12,13,17,18,19,21,22,23,24,25,27,30,34,35,36,37,38,39,40,41,42,43,45,47,49,50,51,52,53,56,57,58,59,60,61,62,66,67,69,71,72,73,81,82,83,84,85,87,90,96,100,101,102,103,104,105],"textures":[1,7,9,10,13,14,16,17,30,33,41,43,49,50,53,57,60,68,69,70,73,84,87,90,93,94,95,96,100,101,105],"flats":[1,8,9,13,14,16,30,33,43,53,57,60,68,69,73,87,90,96,100,105],"sprites":[1,43,47,51,53,57,60,69,73,87,90,96,100],"other":[1,7,13,17,25,27,28,30,31,32,33,36,41,44,72,80,82,85,101,104],"information":[1,4,7,10,11,14,15,16,18,20,36,39,40,41,49,50,51,52,80,81,101,105],"read":[1,39,40,42,52,101],"used":[1,7,8,9,10,11,13,14,16,18,19,25,36,41,42,43,45,47,48,49,50,51,53,55,57,58,60,61,68,69,71,73,79,81,83,84,85,87,89,90,96,100,101,103,105],"during":[1,6,13,102],"supports":[1,14,37,38,51,52,53,57,60,68,69,73,87,90,96,100],"wad":[1,7,11,12,14,39,40,41,51,53,57,60,69,73,87,90,96,100,105],"files":[1,7,13,34,35,36,37,38,39,40,41,49,50,51,52,53,57,59,60,69,73,87,90,96,100,101,103,105],"pk3":[1,14,41,53,57,60,68,69,73,87,90,96,100,101,104,105],"directories":[1,41,103],"resources":[1,7,11,12,13,14,39,40,41,53,57,60,69,73,87,90,96,100,101,104,105],"collection":[1,36],"data":[1,42,45,82,101],"include":[1,17,36,39,40,51,53,57,60,69,73,87,90,96,100,104,105],"sounds":[1,41,79],"but":[1,5,7,11,12,13,14,18,34,35,36,37,38,39,40,42,44,53,57,60,69,73,79,80,81,82,87,90,96,99,100,105],"also":[1,2,3,4,7,8,9,10,11,12,13,16,17,18,24,26,30,32,33,36,39,40,41,42,45,47,48,51,52,53,55,57,60,61,64,65,67,69,70,72,73,75,80,81,82,84,85,87,90,93,96,100,104,105],"most":[1,2,3,4,7,11,12,13,14,15,25,34,35,36,39,40,44,52,53,55,57,60,69,73,82,87,90,96,100],"common":[1,4,14,36,44,81],"type":[1,5,10,15,16,18,26,41,42,48,49,50,51,53,57,59,60,61,68,69,73,81,83,87,88,90,96,99,100,101,105],"by":[1,4,5,6,7,10,11,12,13,14,16,17,18,19,24,25,30,33,34,35,36,37,38,39,40,41,42,43,44,45,47,48,49,50,51,52,53,56,57,60,61,64,67,68,69,70,72,73,75,76,77,79,80,81,82,84,87,90,93,96,100,101,102,104,106],"be":[1,2,3,5,6,7,8,10,11,12,13,14,15,16,17,19,23,25,26,30,32,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,53,55,56,57,58,59,60,61,62,64,65,66,69,71,72,73,80,81,82,83,84,85,87,88,89,90,96,99,100,101,102,103,104,105],"iwad":[1,7],"internal":[1,15,47,51],"contains":[1,9,13,36,39,40,47],"all":[1,2,3,6,7,9,10,11,12,13,16,18,21,22,33,36,37,38,39,40,43,44,45,51,52,53,57,60,61,62,66,67,69,73,81,82,84,87,88,90,93,95,96,99,100,101,102,105],"needed":[1,4,24],"run":[1,7,37,38,81],"without":[1,7,30,42,47,51,53,57,60,65,69,73,87,90,92,96,100,105],"any":[1,4,5,7,10,13,14,24,26,27,28,29,30,31,32,33,34,35,36,44,45,48,53,57,60,61,63,64,66,69,71,73,80,82,83,85,87,90,96,100,102,104],"additional":[1,7,42,49,50,51,53,57,60,65,69,73,75,76,77,78,84,87,90,96,100,101],"pwad":[1],"patch":[1,11,12,14,68,101],"only":[1,7,9,10,11,12,13,14,16,18,19,20,25,27,28,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,55,57,60,61,65,66,67,69,72,73,82,83,84,87,90,92,96,100,101,105,106],"wish":[1,7,10,11,12,13,29,30],"change":[1,4,5,7,8,10,11,12,13,14,16,18,24,36,41,53,57,60,69,73,75,78,87,90,92,96,99,100,104],"example":[1,11,36,37,38,41,42,43,44,45,47,48,49,50,51,58,59,61,67,88,89,99,102,105],"new":[1,5,13,19,24,27,28,31,32,33,34,35,39,40,41,47,49,50,53,57,59,60,61,69,70,73,81,85,87,90,96,99,100,101],"some":[1,4,7,10,11,13,16,18,20,25,29,30,36,42,53,57,60,69,73,83,84,87,88,90,92,96,100,104],"no":[1,7,17,37,38,41,43,44,45,47,53,57,60,69,71,73,82,87,90,96,100,102],"always":[1,11,12,13,21,22,34,35,41,43,81,82,103,105],"requires":[1,45,103],"single":[1,10,27,28,36,37,38,41,47,48,53,57,60,69,73,82,87,90,96,100],"optionally":[1],"one":[1,2,3,7,10,15,17,19,23,24,25,26,27,28,30,31,32,41,45,48,49,50,53,57,59,60,66,69,70,73,80,81,82,84,87,90,93,95,96,100,102,105],"more":[1,2,3,7,10,13,14,15,16,17,18,20,25,53,57,60,66,69,73,81,82,87,90,92,96,100,104],"pwads":[1],"actually":[1],"zip":[1,41,103],"with":[1,5,7,8,9,10,11,12,13,14,15,19,21,22,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,41,42,43,44,45,47,48,49,50,51,53,57,60,66,67,69,70,71,72,73,80,81,82,84,87,90,92,93,96,100,101,102,103,105,106],"structure":[1,14,36,41,42,43,44,45,46,47,48,51,53,57,60,68,69,73,87,90,96,100],"it":[1,4,5,6,7,8,10,11,12,13,14,15,17,18,19,21,22,24,25,29,33,34,35,36,37,38,39,40,41,42,45,48,49,50,51,52,53,57,58,59,60,61,63,65,66,67,69,72,73,80,81,82,85,87,88,90,92,93,96,99,100,102,103,104,105,106],"replacement":[1,14],"sourceports":[1,7,11,12,14,34,35],"smaller":[1,13,23],"than":[1,15,17,52,53,57,60,69,73,87,90,96,100,101],"because":[1,11,12,36,39,40,41,45,99,101,106],"compressed":[1,41],"better":[1,13,52],"performance":[1,7,13,103],"recommended":[1,7,10,17,25,34,35,37,38,82,102,106],"unzip":[1],"your":[1,2,3,4,5,7,8,9,11,12,13,15,17,19,23,24,25,26,27,29,30,31,32,33,34,35,36,39,40,41,45,51,59,61,82,85,103,104,105],"keeping":[1],"add":[1,5,7,10,17,36,42,44,45,47,53,57,58,59,60,61,69,73,81,82,83,87,88,90,96,100,101,103,104],"see":[1,7,9,10,11,12,13,14,16,17,18,20,26,33,34,35,36,41,45,47,49,50,51,53,57,60,69,73,81,82,87,90,96,100],"using":[1,7,10,13,16,18,25,26,30,36,41,42,47,48,51,52,53,55,57,59,60,61,62,68,69,71,72,73,75,76,81,82,84,85,87,90,92,93,96,100,101,103,104,105,106],"zips":[1],"element":[1,4,5,26,53,57,60,61,69,72,73,87,90,96,100],"consists":[1,4,37,38],"vertices":[1,20,24,32,53,55,57,60,69,73,82,83,87,90,92,96,100],"linedefs":[1,10,13,23,27,30,32,41,42,45,51,53,57,60,61,64,67,69,71,72,73,79,80,83,84,87,90,93,96,100],"sidedefs":[1,10,13,27,30,33,41,42,46,53,57,60,69,73,87,90,96,100],"sectors":[1,10,13,16,24,27,28,30,32,41,42,44,53,57,60,61,64,66,67,69,72,73,79,80,81,82,83,84,85,87,90,92,96,100],"things":[1,13,18,19,25,31,33,34,35,36,39,40,42,43,47,48,51,52,53,57,60,61,62,64,67,69,72,73,80,83,85,87,89,90,92,96,100,101],"these":[1,4,6,7,10,13,21,22,34,35,36,37,38,39,40,41,42,44,45,47,51,53,55,57,59,60,69,73,79,84,87,90,92,95,96,100,103,104,105,106],"are":[1,4,5,7,8,10,11,12,13,14,15,16,17,18,19,20,21,22,24,26,29,30,33,34,35,36,37,38,39,40,41,42,43,44,45,47,48,49,50,51,52,53,57,58,59,60,61,62,69,71,72,73,75,79,80,81,82,83,84,87,90,92,93,94,96,100,101,102,103,104,105,106],"elements":[1,8,10,16,18,20,26,53,57,60,61,65,67,69,72,73,86,87,90,96,99,100,102],"each":[1,7,9,10,15,17,19,43,44,45,49,50,53,56,57,60,69,73,81,85,87,88,90,95,96,100],"has":[1,2,3,5,9,10,15,17,27,32,33,41,53,57,58,60,69,73,76,81,84,87,90,96,100,105],"their":[1,5,7,11,12,18,27,33,36,53,57,60,61,69,73,82,87,90,93,96,100,102],"own":[1,5,7,9,15,17,18,19,34,35,36,42,45,102,104],"set":[1,5,7,9,10,13,16,17,18,19,33,41,42,43,44,45,46,47,48,51,53,57,58,59,60,61,66,69,73,79,80,81,84,85,87,90,96,99,100,105],"properties":[1,5,10,16,18,20,27,28,30,31,33,48,51,53,57,60,61,66,69,73,81,82,87,90,96,100,101,104],"connected":[1,62,94],"linedef":[1,10,13,16,23,27,32,33,41,42,45,48,53,57,58,60,61,69,71,73,84,87,90,93,96,100,102],"two":[1,10,32,36,37,38,41,61,80,82,84],"sidedef":[1,10,27,41,42,46,53,57,60,69,73,87,90,95,96,100],"sector":[1,10,13,16,18,24,28,30,41,42,44,47,48,53,57,60,61,66,69,70,73,79,81,82,85,87,90,93,96,100,101,102,104],"vertex":[1,13,20,24,25,27,32,53,57,60,69,73,82,85,87,90,92,93,96,100],"simple":[1,44,82,102],"point":[1,53,57,59,60,69,73,87,89,90,93,96,100,103],"x":[1,53,57,60,69,73,87,90,95,96,100,103],"y":[1,53,57,60,69,73,87,90,95,96,100],"coordinates":[1,4,20,32,43,53,57,60,69,73,87,90,96,100],"line":[1,10,24,37,38,41,45,48,49,50,51,53,57,59,60,67,69,73,79,80,87,90,92,93,96,100,103,104,105],"geometry":[1,13,24,25,27,28,30,32,47,51,53,57,60,69,73,77,82,84,87,90,96,100],"connects":[1],"every":[1,2,3,5,7,27,30,36,42,44,47],"wall":[1,33],"border":[1,81,82],"must":[1,12,19,34,35,36,37,38,41,42,43,44,45,47,48,51,59,105],"have":[1,5,9,10,11,12,13,14,17,21,22,36,37,38,43,44,45,53,57,59,60,66,67,69,71,73,79,81,82,84,87,88,90,95,96,99,100,101,103,104,106],"action":[1,4,10,13,18,33,41,45,47,48,51,53,55,57,60,61,62,63,67,69,71,73,75,76,77,78,79,80,81,82,83,84,85,86,87,89,90,92,93,94,95,96,100],"triggered":[1],"when":[1,4,6,7,8,9,10,11,12,13,14,15,16,17,18,20,23,24,25,28,30,32,33,34,35,36,39,40,41,42,43,44,45,47,48,49,50,51,52,53,57,58,59,60,61,62,64,65,69,70,72,73,75,76,77,80,81,82,83,85,87,90,96,100,102,104,105,106],"player":[1,36,45],"pushes":[1],"walks":[1,45],"over":[1,8,28,45,82],"front":[1,10,27,53,57,60,69,73,87,90,93,96,100],"right":[1,4,7,10,13,16,18,19,24,27,33,41,53,57,60,61,67,69,73,80,81,82,84,87,90,96,100,103],"back":[1,5,10,27,33,36,53,57,60,64,69,73,87,90,93,96,100],"left":[1,4,7,9,10,13,16,18,19,24,27,33,41,53,57,60,69,73,81,82,87,90,96,100],"side":[1,10,27,41,53,57,60,69,73,78,81,87,90,93,96,100],"where":[1,7,11,12,13,19,24,36,42,59,65,89,101,105],"attached":[1,32,58],"should":[1,7,41,42,43,44,45,47,49,50,51,81,85,103],"nothing":[1,7,52,66],"behind":[1,79],"void":[1,28,30,58],"defines":[1,37,38,41,47,49,50,82],"looks":[1,7],"like":[1,33,36,47,48,49,50,51,52,53,57,58,60,65,69,71,73,81,82,87,90,92,93,96,100,104],"forms":[1,53,57,58,60,69,73,87,90,96,100],"upper":[1,33,41,45,53,57,60,69,73,84,87,90,96,100],"middle":[1,41,53,57,60,69,73,87,90,96,100],"lower":[1,33,41,45,48,53,57,60,69,73,84,87,90,96,100],"texture":[1,7,8,9,10,11,12,13,14,17,33,41,42,43,48,53,57,60,68,69,73,81,87,90,93,94,96,100,105],"sometimes":[1],"required":[1,7,24,37,38,42,44,45,82,101,102,103,105,106],"depending":[1,10,24,26,83],"heights":[1,30,53,57,60,69,70,73,84,87,90,96,100],"share":[1,13,36,45],"same":[1,7,9,13,15,21,22,30,36,37,38,41,43,44,45,51,53,57,60,69,73,80,81,82,85,87,90,94,96,99,100,105],"offsets":[1,33,41,43,53,57,60,69,73,85,87,90,92,93,96,100],"area":[1,4,10,11,12,13,16,17,18,30,53,57,60,63,65,69,73,81,82,87,90,96,100],"floor":[1,16,18,30,41,44,47,48,51,53,57,60,69,70,73,81,82,84,85,87,90,93,96,100,101],"ceiling":[1,16,30,33,41,44,47,48,51,53,57,60,69,70,73,81,82,84,87,90,93,96,100,101],"special":[1,7,10,13,16,18,41,48,51,53,57,59,60,67,69,73,87,90,96,100,101],"effects":[1,16,44,53,55,57,60,67,69,73,87,90,96,100],"environment":[1,53,57,60,69,73,80,87,90,96,100,101],"shape":[1,8,13,48,51,76,77,84],"defined":[1,36,37,38,41,49,50,51,53,57,60,68,69,73,82,87,90,96,100,101,104],"they":[1,7,10,15,16,18,20,27,41,43,53,57,60,69,73,87,90,96,100,101,102,105],"closed":[1,15,23,24,25,28,77],"multiple":[1,10,15,16,18,20,23,28,36,53,56,57,60,69,73,80,82,87,88,90,96,100],"areas":[1,9,28,80],"there":[1,7,15,34,35,36,41,42,43,44,52,59,63,65,80,81,88],"exceptional":[1],"cases":[1,7,36],"however":[1],"authors":[1],"non":[1,41,45,80],"create":[1,7,13,19,23,28,30,34,35,39,40,53,57,59,60,69,71,73,78,81,82,84,85,87,90,92,96,100,103],"effect":[1,16,42,44,48,53,57,60,67,69,73,87,90,96,100],"exploiting":[1],"thing":[1,10,13,18,21,22,31,41,42,45,47,48,51,53,57,58,60,65,66,69,73,80,87,88,89,90,96,100,101],"basically":[1],"object":[1,33],"part":[1,2,3,13,34,35,45],"its":[1,5,8,9,15,17,28,36,42,45,81,82],"decorations":[1,51],"items":[1,5,7,11,12,26,36,47,51,55,58,71],"monsters":[1,7,10,18,41,47,51,88,104],"starts":[1,24,27,30,39,40],"even":[1,7,13,15,47,51,72,106],"indicators":[1],"sourceport":[1,5,7,18,34,35,41],"something":[1,26,51],"location":[1,53,57,60,65,68,69,73,87,90,96,100],"format":[1,5,7,10,11,14,15,16,18,20,36,41,42,45,47,48,51,53,57,60,67,69,73,81,85,87,90,92,96,100,102],"z":[1,18,53,57,60,69,73,82,87,90,92,96,100,101],"coordinate":[1],"often":[1,36,39,40],"relative":[1,18,36,53,57,60,66,69,73,82,87,90,96,100],"about":[2,3,4,7,14,15,18,21,22,34,35,36,37,38,39,40,45,49,50,53,57,60,69,73,80,81,87,90,96,100,103,104],"user":[2,3,39,40,41,42,44,45,53,57,60,69,73,79,80,87,90,96,100],"interface":[2,3,4,13,23,37,38,39,40,41,42,53,57,60,69,73,87,90,96,100,105],"s":[2,3,7,13,15,27,30,33,37,38,39,40,41,42,43,44,45,47,48,49,50,51,52,53,57,58,59,60,63,65,66,69,73,81,84,85,87,88,90,93,95,96,100,101,102,103,104,105],"exists":[2,3,36],"main":[2,3,4,7,13,23,26,53,57,60,69,71,73,87,90,96,100,103,105],"window":[2,3,4,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,23,26,29,37,38,41,51,53,57,60,66,69,73,81,84,87,90,96,100,101,105],"will":[2,3,5,6,7,9,10,11,12,13,14,15,16,17,18,20,21,22,23,24,25,26,30,32,33,34,35,36,39,40,41,42,43,44,45,47,48,49,50,51,53,57,58,59,60,61,62,63,64,65,69,71,72,73,79,80,81,82,84,85,87,88,90,95,96,99,100,101,102,105],"done":[2,3,49,50,61,81],"scripting":[2,3,49,50,53,57,58,59,60,69,73,87,90,96,100],"several":[2,3,13,14,34,35,53,55,57,59,60,61,62,66,69,71,73,81,87,88,90,96,100,103],"built":[2,3,13,41,101],"dialogs":[2,3],"setting":[2,3,10,13,16,17,18,19,20,36,37,38,41,43,44,45,53,57,59,60,61,64,69,73,78,84,85,87,90,94,96,100],"preferences":[2,3,13,53,57,59,60,62,64,65,66,69,73,87,90,92,96,100,104,105],"much":[2,3,13,53,57,58,60,69,73,87,90,92,96,100],"help":[2,3,41,45,49,50,52,53,57,58,60,69,73,80,87,90,96,100,103],"explain":[2,3],"buttons":[2,3,4,7,10,17,21,22,24,29,30,81,82],"controls":[2,3,13,21,22,23,24,25,27,28,30,31,32,33,53,57,60,66,69,73,84,87,90,94,96,100],"following":[4,7,36,37,38,39,40,42,49,50,79,80,81,82,101,102,105],"parts":[4,84,101],"menus":[4],"very":[4,34,35,36,52,81,102],"straight":[4],"forward":[4,33,53,57,60,69,73,87,90,96,100],"ll":[4,13,59,83,84,101,103,104,106],"find":[4,6,7,10,14,15,21,22,26,34,35,39,40,53,57,60,61,68,69,73,80,87,90,96,100,101,104],"features":[4,36,39,40,52,53,55,57,58,60,69,73,87,90,96,100],"usual":[4],"places":[4,53,57,60,69,73,87,90,96,100,103],"related":[4,7,13,41,67],"menu":[4,6,7,8,11,13,19,48,51,52,53,55,57,59,60,67,69,71,73,75,76,77,78,81,82,83,84,85,86,87,89,90,93,96,100,103],"view":[4,9,13,19,23,53,55,57,58,60,61,63,67,69,73,80,84,87,90,96,100],"edit":[4,5,8,10,11,13,15,16,18,19,20,25,26,27,28,30,31,32,33,41,42,45,47,48,51,53,57,58,60,61,66,67,69,73,81,82,86,87,88,90,92,96,99,100,101,102],"toolbar":[4,7,24,25,30,31,53,55,57,60,62,69,71,72,73,87,90,92,96,100],"options":[4,7,10,11,12,13,14,36,41,44,45,46,53,57,60,67,69,73,84,87,90,96,100,104,105],"below":[4,10,11,13,16,18,19,29,36,81],"panel":[4,13,51,53,57,58,60,69,70,73,75,76,77,78,87,90,96,100],"highlighting":[4,15,49,50,81,102],"targeting":[4],"working":[4,13],"small":[4,23,29,59],"summary":[4,13],"displayed":[4,17,18,26,29,30,41,44,48,51,53,57,60,69,73,80,81,87,90,96,100],"minimize":[4],"clicking":[4,17,19,24,25,53,56,57,60,69,73,80,82,87,90,96,99,100],"little":[4],"arrow":[4,47,51,53,57,60,69,73,87,90,96,100],"button":[4,6,7,19,24,26,29,33,45,48,51,53,57,60,61,66,69,72,73,75,76,77,81,82,83,84,87,90,96,100,103],"maximize":[4],"statusbar":[4,8],"shows":[4,11,12,23,26,29,36,53,57,60,69,73,79,80,81,87,90,96,100,105],"current":[4,13,15,36,41,49,50,53,57,60,61,63,67,68,69,72,73,75,76,78,81,82,86,87,90,96,100,101],"status":[4],"led":[4],"turns":[4,13],"green":[4,36,47,51,79,81,103],"idle":[4,51],"yellow":[4,47,51,79,82],"means":[4,19,23,24,25,43,53,57,60,69,72,73,82,87,90,96,100],"doing":[4,81],"background":[4,8,13],"work":[4,7,8,15,33,34,35,45,51,52,53,57,60,61,69,73,87,90,92,93,96,100],"red":[4,36,47,48,51,79,82],"then":[4,5,7,10,16,26,36,37,38,53,57,59,60,61,63,65,66,69,71,73,81,84,87,90,96,100,103],"busy":[4],"performing":[4],"next":[4,13,15,24,53,57,60,69,73,87,90,96,100],"description":[4,29,44,49,50,81,82],"result":[4,11,12,14,17,18,36,49,50,53,57,60,61,69,73,87,90,96,100],"flashes":[4],"grid":[4,8,24,27,30,31,32,53,57,60,69,73,75,76,78,84,86,87,90,96,100],"size":[4,8,13,41,43,48,51,53,57,60,68,69,73,75,76,78,87,90,96,100],"mappixels":[4,8,30,33],"zoom":[4,23,26,29],"percentage":[4],"mouse":[4,13,21,22,24,25,27,28,32,53,57,60,63,65,69,73,81,82,87,89,90,96,100],"click":[4,5,6,8,9,10,16,17,19,26,28,29,53,57,60,61,66,67,69,73,79,80,87,88,90,96,100,103],"bring":[4],"allows":[4,5,10,11,12,13,15,16,18,20,21,22,24,25,30,32,47,48,51,55,58,63,67,82,85,94,99],"settings":[4,7,8,10,13,18,19,34,35,36,39,40,41,42,43,44,45,46,47,48,49,50,53,55,57,60,66,69,70,73,83,85,87,90,94,96,100,105],"custom":[5,7,10,16,18,20,42,47,51,53,57,59,60,69,71,73,82,87,90,96,99,100],"fields":[5,10,16,18,20,41,42,53,57,60,69,73,82,87,90,92,96,100],"udmf":[5,10,16,18,20,41,42,44,45,46,47,53,55,57,60,66,67,69,73,80,81,82,85,87,90,92,93,96,99,100,101],"number":[5,7,10,16,18,23,36,41,44,48,51,53,57,60,61,67,69,73,76,78,87,90,96,100,103],"known":[5,14,18,43],"ones":[5,7,11,12,36,37,38,39,40,53,57,60,69,73,87,88,90,95,96,100],"yourself":[5,21,22],"configuration":[5,7,10,11,12,13,18,19,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,53,56,57,59,60,68,69,73,87,90,96,100,101,104,105],"supported":[5,15,47,48,49,50,51,53,57,60,69,73,75,87,90,96,100,101,102,104],"automatically":[5,6,7,10,13,15,30,32,39,40,42,77,81,101,103,105,106],"shown":[5,13,45,47,48,49,50,51,53,57,58,60,61,62,69,73,81,87,90,96,100,102,105],"list":[5,7,9,11,12,13,15,17,18,26,29,41,43,44,45,48,49,50,52,53,57,60,61,69,73,80,81,87,90,96,100,101,102],"grayed":[5,10,16,18,19,20,81],"been":[5,9],"thus":[5],"default":[5,6,7,11,13,23,24,25,27,28,30,31,32,33,39,40,41,42,43,44,45,47,48,49,50,51,53,57,60,63,64,65,66,69,70,73,75,76,77,78,79,80,81,82,83,84,85,86,87,89,90,94,95,96,100,104,105],"value":[5,10,16,18,20,26,36,37,38,41,42,43,44,45,47,48,49,50,51,53,57,60,61,69,73,82,87,90,96,99,100,101],"text":[5,9,10,15,16,36,48,49,50,51,52,53,57,58,59,60,61,67,69,73,81,87,90,96,100,101],"field":[5,9,10,11,16,18,19,20,42,53,57,60,69,73,87,90,96,99,100,103],"name":[5,7,9,10,11,16,17,19,36,37,38,41,42,43,44,45,47,48,49,50,51,53,57,58,59,60,69,73,87,90,94,96,100,101,104,105],"property":[5,41,45,48,51,66,83,101,104],"remove":[5,6,10,19,30,32,48,53,57,58,60,67,69,70,73,80,81,82,87,90,96,100],"just":[5,10,36,45,52,59,81,82,92],"select":[5,7,8,9,12,13,18,19,26,29,30,33,53,55,57,58,60,61,66,69,72,73,81,82,84,87,88,89,90,92,95,96,100],"press":[5,9,13,24,29,45,53,57,59,60,61,66,69,73,75,76,77,80,81,82,84,87,89,90,96,100,103],"delete":[5,19,27,30,31,32,53,57,60,69,73,80,82,87,90,92,96,100,102,103],"cannot":[5,15,39,40,99],"deleted":[5,53,57,60,69,73,87,90,96,100],"pressing":[5,6,24,25,53,57,60,61,69,73,75,76,77,81,82,87,90,96,100],"selected":[5,6,7,10,12,13,16,18,19,20,26,27,30,31,32,33,45,48,53,57,60,61,65,66,69,70,72,73,81,82,83,86,87,88,90,92,93,94,95,96,99,100,101,105],"reset":[5,53,57,60,69,73,87,90,96,100],"errors":[6,34,35,53,57,60,69,73,87,90,96,100,104],"warnings":[6,34,35,53,57,60,69,73,87,90,96,100,104],"occur":[6],"certain":[6,7,39,40,101],"operations":[6,25,41],"reported":[6],"if":[6,7,9,10,13,15,16,17,18,19,26,30,34,35,36,41,43,45,47,48,49,50,51,52,53,57,58,60,61,65,66,67,68,69,71,73,78,80,81,82,84,87,88,90,92,93,96,100,101,103,104,105,106],"does":[6,13,15,33,36,37,38,41,42,43,82],"show":[6,8,9,12,13,17,19,29,30,31,34,35,36,42,49,50,51,53,57,60,61,67,69,71,73,81,87,90,96,100,101,105],"tools":[6,7,13,36,53,57,60,66,69,73,85,87,90,96,100],"key":[6,7,9,11,13,21,22,25,37,38,51,53,57,59,60,63,65,66,69,73,75,76,77,78,79,80,81,82,83,84,85,86,87,89,90,92,94,96,100],"f11":[6],"copy":[6,7,8,42,45,48,53,57,60,69,73,81,84,87,90,96,100],"selection":[6,9,10,13,16,18,20,25,26,33,47,51,53,57,60,64,69,72,73,82,83,87,90,95,96,100],"clipboard":[6,53,57,60,69,73,87,90,96,100],"clear":[6,10,53,57,58,60,67,69,73,87,90,92,96,100],"choose":[6,7,11,12,13,15,30,44,56,71,80,84,103],"open":[6,12,15,17,41,53,57,60,61,66,67,69,73,81,82,87,90,96,100,103,105],"after":[6,13,51,53,57,58,59,60,69,73,75,76,77,78,81,83,87,90,93,96,99,100,103,105],"loading":[6,11,12,14,41,101,105],"checking":[6,47,51],"option":[6,13,42,44,45,48,51,53,57,60,65,69,72,73,87,90,96,100],"configurations":[7,9,11,17,34,35,36,37,38,39,40,41,45,49,50,53,57,59,60,69,73,87,90,96,100,105],"accessible":[7,25,26],"f6":[7],"want":[7,8,13,17,19,21,22,24,26,36,51,59,61,63,65,66,78,81,82,84,88,89,95,101],"tabs":[7,13,36],"loaded":[7,9,11,12,13,37,38,41,42,43,49,50,53,57,60,69,73,87,90,96,100,101,105],"before":[7,25,53,57,60,69,73,83,87,90,93,96,100,103],"project":[7,34,35,39,40,41,103],"so":[7,13,17,21,22,27,36,44,45,47,51,52,53,57,58,59,60,69,71,73,81,82,87,88,90,93,96,99,100,101,103],"top":[7,8,11,12,13,16,17,26,36,41,53,57,60,69,71,73,81,85,87,90,96,100,103],"bottom":[7,9,41,53,57,60,69,71,73,81,87,90,96,100],"first":[7,11,12,24,30,36,39,40,47,51,53,57,60,68,69,73,81,87,90,96,100,103],"drag":[7,11,12,13,25,27,30,31,32,33,53,57,60,69,73,81,82,87,90,96,100],"order":[7,11,12,30,36,62],"nodebuilder":[7,37,38,41,42],"building":[7],"bsp":[7],"tree":[7,80],"blockmap":[7,42],"reject":[7,37,38,42],"useful":[7,8,9,13,28,41,51,53,57,60,69,73,81,87,90,96,100,101,102],"optimize":[7],"older":[7,11,12,14,24,102],"vanilla":[7,41],"saving":[7,41],"testing":[7,41,63,104,105],"consult":[7],"documentation":[7,18,52],"out":[7,81,84],"need":[7,12,13,24,43,44,51,59,61,84,101,103,104,106],"users":[7,10,34,35,102],"may":[7,10,11,13,16,18,19,20,27,32,36,101],"writing":[7,34,35],"matter":[7,17,37,38,43],"well":[7,18,53,57,60,63,66,69,73,81,87,90,96,100],"performs":[7],"essential":[7],"test":[7,41,56,63],"parameters":[7,37,38,41,49,50,101,104,105],"skill":[7,31,41],"level":[7,11,12,16,31,33,41,75,76,77,78,84],"easily":[7,8,99],"changed":[7,8,47,51,53,57,60,62,69,73,87,90,96,100],"drop":[7,13,49,50,53,56,57,58,59,60,61,68,69,71,73,84,87,90,96,100,101],"down":[7,13,24,33,49,50,56,58,59,61,66,68,71,81,84,101],"generally":[7,10,84],"specify":[7,11,12,18,47,48,51,101,105],"fine":[7,103],"placeholders":[7,41],"f":[7,15,27,33,36,52,82],"tested":[7,53,57,60,69,73,87,90,96,100],"note":[7,8,10,11,13,18,27,32,33,36,37,38,43,45,51,80,81,82,92,105],"temporary":[7,49,50],"opened":[7,12,15,71],"saved":[7,23,24,25,53,57,60,69,73,82,87,90,96,99,100,105],"wp":[7],"full":[7,33,53,57,60,69,73,87,90,95,96,100],"path":[7,36,37,38,42,49,50,68,75,76,77,78,81,82,83,84,85,86,105],"included":[7,17,36,104],"highest":[7,53,57,60,69,73,84,87,90,96,100],"found":[7,26,29,36,55,61,66,101,104],"wf":[7],"filename":[7,36,42],"l":[7,27,33,89],"lump":[7,11,15,41,42,43,49,50,68,105],"l1":[7],"warp":[7],"parameter":[7,41,59,105],"l2":[7],"second":[7,36,51,82],"ap":[7],"except":[7,11,12,92,101],"paths":[7,41,103],"separated":[7,41,48,49,50],"spaces":[7,36,59],"placeholder":[7,49,50],"enclosed":[7,28,30],"within":[7,36,51],"quotes":[7],"repeated":[7],"at":[7,8,9,11,12,13,15,16,17,24,26,31,32,33,36,48,52,53,57,59,60,63,65,69,71,73,80,81,82,87,88,90,96,100,101,103,105],"nm":[7],"either":[7,18,23,24,25,36,48,51,81,82,102],"nomonsters":[7],"checkbox":[7,8,11,12,14,19,26,53,57,60,69,73,81,87,90,96,100],"short":[7],"names":[7,36,37,38,41,43,44,45,47,48,51,53,57,58,60,69,73,87,90,95,96,100,101],"msdos":[7,41],"checked":[7,11,12,14,19,81],"above":[7,13,105],"output":[7,37,38,49,50],"filenames":[7,41],"version":[7,34,35,103,106],"compatible":[7,106],"group":[7,51,68,82,101],"into":[7,10,16,28,33,53,57,60,69,73,80,85,87,90,96,100,102,103],"categories":[7,47,51],"called":[7],"sets":[7,9,13,17,47,48,51,83,103],"fixed":[7],"appear":[7,10,16,18,20,25,29,31,63,65],"browsers":[7,53,57,60,69,73,87,90,96,100],"another":[7,26,47,51,53,57,60,69,73,87,90,96,100,102,104],"paste":[7,45,53,57,60,69,73,87,90,96,100],"provided":[7,99],"creating":[7,13,30,41,53,57,59,60,69,73,83,87,90,96,100,101],"plugins":[7,41,52,102,105],"installed":[7,34,35,106],"replace":[7,15,26,53,57,60,69,70,73,87,90,96,100],"require":[7,11,12,14,36,65],"plugin":[7,53,57,60,61,66,67,69,73,79,80,81,82,87,90,96,100,102,105,106],"together":[7,33,45],"changes":[7,13,23,24,25,27,34,35,36,41,48,53,57,60,69,73,84,87,90,96,100,103],"made":[7,10,16,18,20,34,35,64],"setup":[8,56,71,94,103],"configure":[8,13],"icon":[8,56,62,80,81],"access":[8,11,13,19,23,24,25,103],"helps":[8,29,34,35],"aligning":[8,93],"important":[8,30,36,82],"indicates":[8,11,41,42,81],"aligned":[8,47,53,57,60,69,73,87,90,93,96,100],"increase":[8,13,44,53,57,60,61,69,73,75,76,77,78,84,87,90,96,100,101],"decrease":[8,13,44,53,57,60,61,69,73,75,76,77,78,84,87,90,96,100],"drawing":[8,13,24,53,57,60,69,70,73,75,76,77,78,82,84,86,87,90,96,100],"image":[8,9,10,13,16,17,33,47,51,53,57,60,68,69,73,87,90,96,100,101],"check":[8,10,13,26,41,47,49,50,51,53,57,60,61,69,73,78,81,87,90,96,100,103,104],"flat":[8,16,33,41,42,53,57,60,69,73,87,90,96,100,101],"offset":[8,53,57,60,69,73,87,90,92,96,100],"scale":[8,13,43,47,51,53,57,60,66,69,73,85,87,90,93,96,100],"browser":[9,10,13,16,17,26,33,53,57,60,68,69,73,87,90,96,100,101],"named":[9,36,37,38,41,42,45,47,51,58,101],"obviously":[9],"added":[9,44,45,53,57,60,69,73,81,87,90,96,99,100,101,105],"know":[9,10,16,41,101],"resides":[9],"once":[9,17,47,53,57,60,69,71,73,87,88,90,96,100],"chosen":[9,42,45,53,57,60,69,73,87,88,90,93,96,100],"enter":[9,11,16,17,18,19,23,24,25,26,61,67,82,84,99,103],"partly":[9],"images":[9,13,14,47,51,53,57,60,69,73,87,90,96,100,105],"adjust":[9],"match":[9,37,38,42,51,53,57,60,69,73,78,87,90,96,100,103],"entered":[9],"dimensions":[9],"focus":[9,13,26],"tab":[9,10,13,15,16,18,20,36,42,53,57,59,60,69,73,87,90,96,100,103],"jump":[9,53,57,60,69,73,87,90,96,100],"between":[9,11,12,13,14,30,33,41,45,53,57,60,64,65,69,72,73,82,87,90,96,99,100,105],"doubleclick":[9],"ok":[9,53,57,60,61,69,73,84,87,88,90,96,99,100,103],"cancel":[9,84],"close":[9],"dialog":[10,11,12,14,15,16,17,18,19,20,23,26,29,30,34,35,81,82,102,105],"empty":[10,16,18,19,20,42,103],"case":[10,16,18,20,36,45,49,50,61,105],"apply":[10,11,13,16,18,20,23,24,25,33,48,53,57,60,69,71,73,81,87,90,96,100],"entire":[10,11,16,18,20,25,33,36],"general":[10,45,46,47,53,57,60,69,73,87,90,96,100],"both":[10,47,65,78,80,82,83,101,105],"sides":[10,30,41,53,57,60,69,73,76,80,87,90,96,100],"unless":[10,13,42,103,105],"specified":[10,49,50,71,105],"otherwise":[10,104],"provides":[10,13,42,44,45,48,49,50],"impassable":[10,13,41,45],"blocks":[10,13,37,38,41,51,59],"players":[10,41,47],"crossing":[10],"doublesided":[10,13,45],"unset":[10,41,84],"indicate":[10,17,42,43,45,81,105],"feature":[10,53,57,60,69,73,87,90,96,100],"many":[10,13,36,39,40,52,58,81,84],"behaviour":[10,13,41,48,53,57,60,61,65,69,70,72,73,87,90,96,100,104],"executed":[10,18],"trigger":[10,41,48],"method":[10],"switch":[10,29],"proximity":[10],"take":[10],"arguments":[10,18,36,41,48,49,50,53,57,60,61,69,73,87,90,96,100],"independently":[10],"combination":[10,13,24,53,57,60,69,71,73,87,90,96,100,105],"methods":[10,61],"formats":[10,15,18,39,40,41,45,47,53,57,60,69,73,87,90,96,100],"tagged":[10],"identifies":[10],"scripts":[10,15,16,41,42,53,57,58,60,69,73,87,90,96,100],"perform":[10,16,25,26,29,33,41,105],"uncheck":[10,81],"box":[10,13,16,19,33,41,58],"index":[10,36,51],"bound":[10,39,40,41,53,57,60,69,73,87,90,92,96,100],"valid":[10,37,38,63],"changing":[10,11,13,41,53,57,60,69,73,87,90,96,100],"browse":[10,14,15,16,26],"making":[10,24,25,41,102],"dash":[10],"directly":[10,16,42],"f2":[11,15],"please":[11,18,36,43,52],"cause":[11,41,102],"loss":[11],"possibly":[11],"breaking":[11],"store":[11,82],"could":[11,42],"e2m3":[11],"episode":[11],"map03":[11,41],"strictly":[11,12,14,105],"load":[11,12,13,14,41,43,101,104,105],"patches":[11,12,14,43,105],"p_start":[11,12,14,43,105],"p_end":[11,12,14,43,105],"applies":[11,12,24,41,42,52,53,57,60,69,73,87,90,96,100],"resolve":[11,12,14],"conflicts":[11,12,13,14,105],"lumps":[11,12,14,15,41,42,43,52,101,105],"was":[11,12,14,81,85,102],"intended":[11,12,14],"id":[11,12,14,41,45,103],"software":[11,12,14,103,106],"gray":[11,12,47,51,79,80],"those":[11,12,18,36,41,43,80,82,84,101],"according":[11,12,105],"opening":[12,13,36,49,50,53,57,58,60,69,73,87,90,96,100],"lets":[12,13,17,41,66,67,75,76,77,78,81,82,84],"regardless":[13,41,85],"f5":[13,103],"categorized":[13],"preview":[13,23,24,25,53,57,60,69,73,87,90,96,100],"consume":[13],"less":[13,53,57,60,69,73,87,90,96,100],"system":[13,106],"memory":[13],"autoscroll":[13],"speed":[13,81,101],"dragging":[13,25,53,57,60,69,73,81,84,87,90,96,100],"scroll":[13,26],"move":[13,23,25,27,30,31,32,33,36,41,53,57,60,63,65,69,73,81,82,87,90,92,96,100],"towards":[13,53,57,60,69,73,87,90,96,100],"edges":[13,25,81],"scrolling":[13],"slider":[13],"completely":[13,36,47,72],"turn":[13,84],"off":[13,33,84],"automatic":[13,75,76,77,78,105],"factor":[13],"gzdb":[13,41,42,44,45,46,47,48,49,50,51,52,53,57,59,60,63,65,69,73,87,90,96,100,101,102,103,104,105],"handles":[13,25,53,57,60,69,73,87,90,96,100],"classic":[13,23,24,25,26,27,28,29,30,31,32,33,47,48,51,53,57,60,61,62,64,65,66,69,72,73,83,87,90,96,100],"visual":[13,33,41,47,51,53,55,57,60,62,63,64,65,66,69,73,83,87,90,92,94,95,96,100,101,103,104,106],"max":[13,99],"recent":[13,15],"script":[13,15,37,38,41,42,49,50,53,57,58,59,60,69,73,87,90,96,100],"float":[13,42],"sync":[13],"camera":[13,41,53,57,60,63,65,69,73,87,90,96,100],"position":[13,27,36,41,47,49,50,51,53,57,60,63,65,69,73,81,82,87,90,93,96,100],"2d":[13,23,24,25,27,28,30,31,32,53,57,60,62,64,65,69,71,73,84,87,90,96,100],"enabled":[13,39,40,41,44,53,57,59,60,62,64,65,69,72,73,82,85,87,90,96,100,103],"center":[13,53,57,60,69,73,80,81,82,87,90,96,100],"leave":[13,42,52,65],"place":[13,41,53,57,59,60,63,65,69,73,82,87,89,90,96,100],"cursor":[13,15,24,49,50,53,57,59,60,63,65,69,73,81,82,87,89,90,93,96,100],"toggle":[13,33,48,51,53,55,57,60,62,69,71,73,79,80,87,90,92,96,100],"improve":[13],"distance":[13,47,51,93],"keyboard":[13,52,53,57,60,69,73,84,87,90,96,100],"shortcut":[13,15,25,53,57,60,66,69,73,84,87,89,90,96,100],"keys":[13,15,21,22,51,53,57,60,65,69,73,87,90,95,96,100,101],"them":[13,27,30,31,32,33,36,39,40,53,57,60,61,66,67,69,73,80,81,82,84,87,90,92,95,96,99,100,101,102,104],"verify":[13],"safely":[13,34,35,102],"appearance":[13,53,57,59,60,62,69,73,87,90,92,96,100],"aesthetics":[13],"colors":[13,53,57,60,66,69,71,73,79,87,90,92,96,100,101],"font":[13],"regarding":[13,101],"passable":[13],"lines":[13,24,30,41,48,51,53,55,57,60,62,69,73,77,79,80,84,87,90,96,100],"transparency":[13],"translucent":[13,44,45,47,53,57,60,69,73,87,90,96,100,101],"opaque":[13],"singlesided":[13],"removed":[13,30,102],"brightness":[13,16,30,33,44,53,57,60,69,73,81,84,87,90,96,100],"viewing":[13,17],"against":[13],"white":[13,47,51],"dark":[13,47,51,79],"monitor":[13],"maximum":[13,41,48,51,99],"dynamic":[13,47,52,53,55,57,60,66,69,73,87,90,96,100,101,104],"lights":[13,47,52,53,55,57,60,66,69,73,87,90,96,100,101,104],"render":[13,53,57,60,69,73,87,90,96,100,104],"rendering":[13,47,48,51,53,55,57,60,62,69,73,87,90,92,96,100,104],"possible":[13,17,36,41,47,49,50,51,52],"values":[13,36,41,43,44,45,47,48,49,50,51,53,57,60,69,73,75,82,83,87,90,92,96,99,100,101],"light":[13,41,44,47,51,53,57,60,66,69,73,79,87,90,96,100,101,104],"mimics":[13],"intensity":[13],"square":[13,81,82],"collision":[13],"detection":[13],"get":[13,82,83,104],"bounding":[13,33,41],"boxes":[13,82],"high":[13,36],"quality":[13],"display":[13,37,38,41,44,45,48,49,50,51,80,92,101,104],"improves":[13],"pixel":[13,33,106],"shader":[13,106],"model":[13,48,53,55,57,60,69,73,85,87,90,96,100,101,106],"adds":[13,36,81,101,105],"anti":[13],"aliasing":[13],"improved":[13],"turning":[13,14],"gives":[13],"oldschool":[13],"support":[13,41,43,44,45,52,53,57,60,61,69,73,87,90,96,100,101,103,106],"disables":[13,41],"bilinear":[13],"filtering":[13],"enables":[13,41],"removes":[13,24,41,103],"large":[13,36],"zooming":[13],"blurry":[13],"definitions":[13,42,45,47,51,82,101,104],"gldefs":[13,41,49,50,53,57,60,69,73,87,90,96,100,101,104],"warning":[13,41,42,45,59,61,80,103],"reload":[13,34,35,53,57,60,69,73,87,90,96,100,101],"models":[13,47,52,53,57,60,69,73,87,90,96,100,101],"height":[13,16,18,33,47,48,51,53,57,60,69,73,81,82,85,87,90,92,96,100],"scaled":[13],"mimick":[13],"way":[13,24,52,53,57,60,61,69,73,82,87,90,96,100],"black":[13,82],"surfaces":[13,53,57,60,66,69,73,87,90,94,96,100],"highlighted":[13,25,27,28,30,31,41,53,57,60,62,66,69,72,73,79,81,87,90,93,96,100],"highlight":[13,25,41,49,50,53,57,60,66,69,72,73,80,87,90,96,100],"disabled":[13,39,40,44,53,57,59,60,69,73,87,90,96,100],"mark":[13,17],"floors":[13,30,33,43,53,57,60,69,73,81,82,83,87,90,93,96,100],"marked":[13,51],"color":[13,33,36,41,42,47,48,51,53,57,60,62,66,69,71,72,73,82,87,90,92,96,100],"modify":[13,34,35,47,82],"overriden":[13],"draw":[13,24,27,30,53,57,60,69,70,73,75,76,77,78,82,87,90,96,100],"auto":[13,33,53,57,60,69,73,77,87,90,93,95,96,100],"align":[13,25,53,57,60,69,73,84,87,90,93,94,95,96,100],"newly":[13,81],"created":[13,59,81,82,84,85,105],"alignment":[13,33],"applied":[13,33,53,57,60,69,73,81,83,87,90,96,100],"deometry":[13],"don":[13,44,47,48,51,53,57,60,65,69,73,87,90,96,100,101,104],"t":[13,31,33,41,43,44,47,48,51,52,53,57,59,60,61,65,69,73,84,87,90,92,96,100,101,102,104],"outside":[13,25,47,51],"boundary":[13,41,80],"outisde":[13],"boundaries":[13,27],"dragged":[13,53,57,60,69,73,82,87,90,96,100],"moved":[13,53,57,60,65,69,73,87,90,96,100],"inside":[13,30,36,47,49,50,53,57,59,60,69,72,73,81,87,90,96,100,101],"likely":[13,52],"destroying":[13],"shapes":[13,48,51,75,76,77],"process":[13,51],"synchronise":[13],"types":[14,41,42,44,49,50,53,57,60,69,73,87,88,90,96,99,100],"wiki":[14,47,101,102,104],"ways":[14,61,65],"expected":[14,41,53,57,60,69,73,87,90,96,100],"zdoom":[14,47,52,53,57,60,63,69,73,80,87,90,96,100,101,102,104],"simply":[14,81],"root":[14,105],"zipped":[14],"powerful":[15],"syntax":[15,36,51,53,57,60,69,73,87,90,96,100],"autocomplete":[15],"documents":[15],"time":[15,21,22,36,48,82,103],"reside":[15],"page":[15,45,49,50],"ctrl":[15,53,57,60,63,65,69,72,73,75,76,77,83,84,87,89,90,94,96,100],"o":[15,37,38,53,57,60,69,73,87,90,96,100],"save":[15,53,57,60,69,73,85,87,90,96,100,105],"space":[15,36,41,59,81],"autocompletes":[15],"word":[15,49,50],"possibility":[15],"pop":[15,82],"keywords":[15,36,49,50],"opens":[15,26,33,36,53,57,60,69,73,87,90,96,100],"f3":[15,26],"finds":[15,51],"occurence":[15],"search":[15,26,53,57,60,67,69,73,87,90,96,100],"website":[15],"keyword":[15,49,50,53,57,60,69,73,87,90,96,100],"manually":[16,61,103],"tag":[16,18,41,42,48,51,53,57,60,61,67,69,73,81,87,90,96,100],"identify":[16],"while":[17,25,36,53,57,59,60,64,65,69,71,73,82,84,87,90,96,100,104],"results":[17,26,36,53,57,60,69,73,87,90,96,100],"immediately":[17,53,57,60,69,73,82,87,90,96,100,105],"filters":[17,19],"wildcards":[17,37,38,49,50,53,57,60,69,73,87,90,96,100],"question":[17],"exactly":[17],"character":[17,48,49,50,51,53,57,59,60,69,73,87,90,96,100],"asterisk":[17],"zero":[17,41,53,57,60,69,73,87,90,96,100],"characters":[17,53,57,60,69,73,87,90,96,100],"overlap":[17,53,57,60,69,73,85,87,90,96,100],"instantly":[17,33],"matches":[17,93],"matching":[17],"double":[17,27,36,41,43,45,61,67,79,80],"depend":[18],"angle":[18,41,42,47,48,51,53,57,60,69,73,87,90,96,99,100],"usually":[18,53,57,60,69,73,87,90,92,96,100],"absolute":[18,47,51,53,57,60,69,73,87,90,96,100],"refer":[18,37,38],"dies":[18],"give":[18,41,51],"unexpected":[18],"relevant":[19,51,61,101],"filter":[19,31,53,57,60,67,68,69,73,87,90,96,100],"category":[19,33,47,51,53,55,57,59,60,69,73,75,76,77,78,79,80,81,82,83,84,85,86,87,89,90,94,95,96,100],"filled":[19],"pass":[19,49,50],"stored":[19,41,42,49,50,59],"separately":[19],"exact":[20,81],"depends":[21,22],"purposes":[21,22,41,82],"switching":[21,22,65,75,76,77,78],"good":[21,22,51,52],"remember":[21,22,53,57,60,69,73,87,90,96,100],"assigned":[21,22,53,57,60,61,67,69,73,82,87,88,90,96,100,101],"curve":[23,27,53,57,60,69,73,77,87,90,96,100],"split":[23,24,28,32,53,57,60,69,73,81,87,90,96,100],"although":[23],"around":[23,25,30,33,81,82],"volatile":[23,24,25],"returns":[23,24,25],"previous":[23,24,25,33,75,76,77,78],"stable":[23,24,25],"accepting":[23,24,25],"discarding":[23,24,25],"through":[23,27,33,53,57,60,69,73,79,81,87,90,96,100],"accept":[23,24,25,84],"return":[23,24,25],"escape":[23,24,25],"discard":[23,24,25],"lmb":[24,25,28,33,53,57,60,69,73,87,90,96,100],"snap":[24,25,27,30,31,32,41,53,57,60,69,73,86,87,90,96,100],"nearby":[24,25],"behavior":[24,39,40,64,72],"holding":[24,25,53,57,60,64,65,69,73,81,82,87,90,96,100,103],"shift":[24,25,27,30,31,32,33,53,57,60,64,65,69,71,72,73,75,76,81,82,84,87,89,90,96,100],"control":[24,27,30,32,33,49,50,76,77,81,82,84],"ends":[24],"onto":[24,33],"drawn":[24,53,57,60,62,69,73,77,82,87,90,96,100],"polygon":[24,85],"rmb":[24,28,33],"contrary":[24],"editors":[24],"clockwise":[24,53,57,60,69,73,76,87,90,96,100],"complete":[24,42,53,57,60,69,73,87,90,96,100],"traverse":[24],"existing":[24,25,28,37,38,53,57,59,60,69,70,72,73,77,82,84,87,90,96,100],"adjacent":[24,33,53,57,60,69,73,87,90,94,96,100],"solve":[24,105],"crosses":[24,84],"across":[24,94],"creates":[24,81,103],"d":[24,30,33,75,76,77,103],"backspace":[24],"last":[24,30,81],"draws":[24,82],"placing":[24],"snapping":[24,27,30,31,32,84],"e":[25,33,51,53,57,60,61,69,73,80,87,90,92,96,100],"applying":[25,81],"functions":[25,30,36],"rectangle":[25,48,51,53,57,60,69,73,75,87,90,96,100],"grab":[25],"grabbing":[25],"flip":[25,53,57,60,69,73,84,87,90,96,100],"horizontally":[25,33,53,57,60,69,73,78,87,90,92,96,100],"rotating":[25,47,51],"vertically":[25,33,78],"resize":[25,81],"away":[25,89],"ruler":[25],"grabbed":[25],"edge":[25],"rotate":[25,53,57,60,69,73,76,87,90,96,100,101],"corners":[25,75,76,78,81],"normally":[25,41,42],"nearest":[25,27],"degrees":[25,42,48],"hold":[25,27,30,31,32,33,53,57,60,64,69,71,72,73,84,87,89,90,96,100],"freely":[25],"looking":[26,47],"quickly":[26,29,44,66,89],"particular":[26],"disable":[27,30,31,32,41,53,57,60,65,69,73,75,76,77,78,87,90,96,100,104],"switches":[27,28,30,31,32,33],"insert":[27,30,31,32,36,53,57,59,60,69,73,80,87,90,96,100],"deletes":[27,30,31,32],"break":[27,32,59],"flips":[27],"remain":[27],"correct":[27],"splits":[27],"keeps":[27,30,39,40],"sided":[27,41,45,79,80],"c":[27,33,36,37,38,82,103,105,106],"curves":[27,84],"fix":[28,29,84,104],"broken":[28],"islands":[28],"moving":[28,53,57,60,64,69,73,81,82,87,90,96,100],"potential":[28],"m":[28,41,51,103,104],"analysis":[29,51,53,57,60,69,73,87,90,96,100],"finding":[29],"problems":[29,41,80,102],"checks":[29,81],"f4":[29],"start":[29,36,37,38,43,45,53,57,60,61,62,69,73,82,87,90,93,96,100,103],"subject":[29],"problem":[29],"formed":[30],"stairs":[30],"gradient":[30,53,57,60,69,73,87,90,96,100],"long":[30,41],"stay":[30],"numbers":[30,41],"associated":[30,41,49,50],"deleting":[30,32,82],"larger":[30],"hole":[30],"pillar":[30],"instead":[30,36,47,51,53,57,60,69,73,78,84,87,90,96,100,101,105],"j":[30,83],"joins":[30],"become":[30,36,41],"retained":[30],"merge":[30],"joining":[30],"addition":[30,53,57,60,69,73,87,90,96,100,101],"door":[30,41],"g":[30,33,52,53,57,60,61,63,69,73,87,90,92,96,100,101,104],"scrolldown":[30,33,81],"lowers":[30,33],"scrollup":[30,33,81],"raises":[30,33],"multiplayer":[31],"hard":[31,36],"inserts":[31,32],"reconnect":[32],"properly":[32,53,57,60,69,73,87,90,96,100],"v":[32,33],"near":[32,103],"walk":[33],"fly":[33],"would":[33,36,52],"crosshair":[33],"aim":[33],"objects":[33,70,80],"ceilings":[33,53,57,60,69,73,82,83,87,90,93,96,100],"walls":[33,41,43,53,57,60,69,73,83,87,90,96,100,104],"w":[33],"targeted":[33,53,57,60,69,73,87,90,96,100],"mmb":[33],"pastes":[33],"copied":[33,53,57,60,69,73,87,90,93,96,100],"target":[33,41,103],"flood":[33],"fills":[33],"identical":[33],"original":[33,43,105],"clears":[33],"faster":[33,58,106],"backward":[33,53,57,60,69,73,87,90,96,100],"strafe":[33],"gravity":[33],"b":[33,84],"unpegged":[33,45],"flag":[33,41,45,47,48,79,80],"u":[33,52],"boxed":[33],"aligns":[33],"neighbouring":[33],"until":[33,105],"encountered":[33],"vertical":[33,47,51,53,57,60,69,73,78,85,87,90,92,93,96,100],"takes":[33,36,53,57,60,69,73,87,90,96,100],"differences":[33],"account":[33,53,57,60,69,73,87,90,96,100],"copies":[33],"pasting":[33],"ignored":[33,36,41,44,45,47,51],"mappixel":[33],"increases":[33],"decreases":[33],"moves":[33],"pixels":[33],"r":[33],"resets":[33,53,57,60,69,73,87,90,96,100],"flexible":[34,35],"customized":[34,35],"mapping":[34,35,82],"among":[34,35,36],"subdirectories":[34,35,37,38,39,40],"program":[34,35,37,38,39,40,53,57,60,69,73,87,90,96,100,105],"great":[34,35],"examples":[34,35,36,94,105],"separate":[34,35,43,45],"overwritten":[34,35],"restart":[34,35],"follow":[36],"structured":[36],"plain":[36,49,50,59],"edited":[36,42,53,57,60,69,73,82,87,90,96,100],"form":[36,41,45,51,53,57,60,61,69,73,77,87,88,90,96,99,100],"settingname":[36],"few":[36],"doublesidedflag":[36,41],"defaulttexturescale":[36,43],"0f":[36,47],"scaledtextureoffsets":[36,43],"true":[36,41,42,43,44,45,47,49,50,51],"gamename":[36],"rules":[36,105],"contain":[36,44,51,59],"newlines":[36],"dots":[36],"slashes":[36],"unique":[36,37,38,81],"decimal":[36,43,47,53,57,60,69,73,87,90,96,99,100],"dot":[36],"end":[36,43,53,57,59,60,69,73,87,90,93,96,100,102],"boolean":[36,41,42,43,44,45,47,49,50,51],"false":[36,41,42,43,44,45],"strings":[36,43],"texts":[36],"begin":[36,43],"doublequote":[36],"string":[36,41,42,43,44,45,47,48,49,50,51],"prefix":[36,45],"backslash":[36,51],"precense":[36],"absense":[36],"alone":[36],"enough":[36,81],"enablelighting":[36],"style":[36,49,50,53,57,59,60,69,73,87,90,96,100],"comments":[36,51,67,101],"inserted":[36,47,51,53,57,60,69,73,87,90,96,100],"singleline":[36],"block":[36,37,38,45,49,50,51,79,103],"hide":[36],"writings":[36],"wildest":[36],"dreams":[36],"structures":[36],"think":[36],"begins":[36],"bracket":[36],"closes":[36],"closing":[36,49,50],"bracktet":[36],"ident":[36],"easier":[36,53,57,58,60,68,69,73,80,87,90,96,100],"belong":[36,41,80],"winningnumbers":[36],"car":[36],"washmachine":[36],"collections":[36],"describe":[36,82],"hideous":[36],"monster":[36,45,88],"including":[36,42,45,53,57,60,69,73,87,90,96,100],"complex":[36,39,40],"eternity":[36],"inherits":[36],"boom":[36],"pieces":[36],"becomes":[36,41],"interesting":[36],"function":[36,41,49,50,83],"we":[36,84],"override":[36,43,51,53,57,60,69,70,73,87,90,96,100],"saves":[36],"us":[36,103],"rewriting":[36],"already":[36,53,57,59,60,61,69,72,73,77,87,90,96,100,101,106],"mandatory":[36,44,45],"optional":[36,39,40,47,82,103,105],"argument":[36,45,47,48,51,61],"given":[36,47,48,53,57,60,69,73,83,87,90,96,100],"commonsettings":[36],"cfg":[36,37,38,42,49,50,105],"extras":[36],"skills":[36,41],"maxtexturenamelength":[36],"skyflatname":[36,41],"f_sky1":[36,41],"low":[36],"medium":[36],"includes":[36,51,58],"basic":[36,41,81],"thingflags":[36],"easy":[36,82],"notice":[36,52,58,68,71,99,106],"contents":[36,42,52],"container":[36],"itsself":[36],"our":[36],"put":[36,41,51],"none":[36,41,47,51,78,79,80,81,82,85,86,95,102],"ultra":[36,41],"demonstrates":[36],"overridden":[36],"item":[36,53,57,60,62,67,69,73,87,90,96,100],"written":[36,42],"average":[36],"definition":[36,41,47,48,51,101,104],"compiler":[37,38,41,42,49,50,53,57,60,69,73,87,90,96,100,103],"compilers":[37,38,39,40,53,57,60,69,73,87,90,96,100],"nodebuilders":[37,38],"placed":[37,38,49,50,59],"typical":[37,38,88],"uses":[37,38,41,42,45,47,51,53,57,60,69,70,72,73,87,90,96,100,101,104],"exe":[37,38,105],"interal":[37,38],"processing":[37,38],"error":[37,38,41,47,51],"feedback":[37,38],"currenttly":[37,38],"acccompiler":[37,38],"others":[37,38],"zdoom_acc":[37,38],"acc":[37,38,53,57,60,69,73,87,90,96,100],"zcommon":[37,38],"acs":[37,38,49,50,53,57,60,69,73,87,90,96,100],"zdefs":[37,38],"zspecial":[37,38],"zwvars":[37,38],"nodescompiler":[37,38],"zdbsp":[37,38],"various":[37,38,41,75,76,77,94],"presets":[37,38,71],"pick":[37,38,59,61,88],"followed":[37,38],"underscore":[37,38],"fi":[37,38,49,50],"input":[37,38,41,49,50,82],"fo":[37,38,49,50],"zdbsp_normal":[37,38],"title":[37,38,45,47,48,51,101],"normal":[37,38,44,47,49,50,82],"command":[37,38,49,50,52,53,57,60,69,73,87,90,96,100,103,105],"largest":[39,40],"determine":[39,40,41],"hardcoded":[39,40],"subdirectory":[39,40],"searched":[39,40],"wants":[39,40],"detects":[39,40],"detected":[39,40,51,80],"testparameters":[39,40,41],"testshortpaths":[39,40,41],"defaultsavecompiler":[39,40,41],"defaulttestcompiler":[39,40,41],"thingsfilters":[39,40],"texturesets":[39,40],"prevent":[41],"accedential":[41],"buider":[41],"unnamed":[41],"enabledbydefault":[41],"enable":[41,66,72,101],"actionspecialhelp":[41,45],"url":[41,49,50,103],"k":[41,49,50,66],"wildcard":[41],"replaced":[41,49,50,53,57,60,69,73,87,90,96,100,102],"thingclasshelp":[41],"class":[41,42,47,48,51,101,104],"clicked":[41],"classname":[41],"decorate":[41,43,47,48,49,50,51,53,57,59,60,69,73,87,90,96,100,101,104],"actor":[41,47,49,50,51,53,57,60,69,73,87,90,96,100,101,104],"basegame":[41],"doomdefs":[41],"hticdefs":[41],"hexndefs":[41],"strfdefs":[41],"chex":[41,51],"won":[41,47,51,53,57,60,61,69,73,87,90,96,100,104],"namespace":[41,42],"currently":[41,42,48,52,53,57,60,62,69,70,73,77,79,81,87,90,96,100,101],"defaultlumpname":[41],"suggested":[41],"selecting":[41,53,57,60,69,73,87,90,96,100],"launch":[41],"defaultscriptcompiler":[41],"compiling":[41,103],"descriptive":[41],"i":[41,51,52,80,104],"too":[41],"young":[41],"die":[41],"hey":[41],"rough":[41],"hurt":[41],"me":[41,52],"plenty":[41],"violence":[41],"nightmare":[41],"damagetypes":[41,101],"damage":[41,44,48,51,101],"combined":[41],"parsed":[41],"bfgsplash":[41],"drowning":[41],"slime":[41],"internalsoundnames":[41],"logical":[41],"sound":[41,45,53,57,60,69,73,79,80,87,90,96,100,101],"actual":[41],"sndinfo":[41,49,50,101],"death":[41],"xdeath":[41],"wimpydeath":[41],"crazydeath":[41],"burndeath":[41],"ignoredextensions":[41],"extensions":[41,49,50],"pk7":[41,53,57,60,68,69,73,87,90,96,100],"bak":[41],"backup1":[41],"backup2":[41],"backup3":[41],"rar":[41],"7z":[41],"ignoreddirectories":[41],"svn":[41,102,103],"git":[41,103],"linetagindicatesectors":[41],"really":[41],"tags":[41,53,57,60,61,67,69,73,81,87,90,96,100],"singlesidedflag":[41],"integer":[41,42,45,47,48,49,50,51,53,57,60,69,73,87,90,96,99,100],"numeric":[41,42,44,45,47,48,53,57,60,69,73,87,90,96,100],"flags":[41,42,45,47,48,53,57,60,69,71,73,81,87,90,96,100,101,105],"indicating":[41],"impassableflag":[41],"blocking":[41,45,47,79],"specifying":[41],"leftboundary":[41],"rightboundary":[41],"topboundary":[41],"bottomboundary":[41],"safeboundary":[41],"considered":[41,99],"safe":[41],"defaultwalltexture":[41],"startan":[41],"defaultfloortexture":[41],"floor0_1":[41],"defaultceilingtexture":[41],"ceil1_1":[41],"makedoortrack":[41],"makedoordoor":[41],"makedoorceil":[41],"makedooraction":[41],"makedoorarg":[41],"doomlightlevels":[41],"linear":[41,84],"lighting":[41],"simulation":[41],"doomthingrotationangles":[41],"resulting":[41],"degree":[41],"increments":[41,53,57,60,69,73,87,90,96,100],"localsidedeftextureoffsets":[41],"individual":[41,58],"affects":[41],"start3dmode":[41],"keep":[41,51,81,82],"along":[41,42,44],"interpreted":[41],"sky":[41,55],"meaning":[41],"defaultskytextures":[41],"relationship":[41],"sky1":[41],"map01":[41,105],"map02":[41],"map04":[41],"map05":[41],"sky2":[41],"map12":[41],"map13":[41],"map14":[41],"map15":[41],"map16":[41],"sky3":[41],"map21":[41],"map22":[41],"map23":[41,105],"map24":[41],"map25":[41],"longtexturenames":[41],"chars":[41],"limit":[41,80],"validity":[41],"enabling":[41,53,57,60,64,69,73,87,90,96,100],"incompatible":[41],"lead":[41],"slade":[41],"limitation":[41],"sidedefcompressionignoresaction":[41],"db2":[41,65,102],"potentially":[41,102],"source":[41,49,50,81,102,103,104],"port":[41],"doesn":[41,43,53,57,59,60,61,65,69,73,87,90,96,100,102,104],"decompress":[41],"skipped":[41],"compressing":[41],"formatinterface":[42],"write":[42,52],"doommapsetio":[42,47],"hexenmapsetio":[42,47],"universalmapsetio":[42,47],"maplumpnames":[42],"describes":[42],"nodes":[42,53,57,60,69,73,87,90,96,100,106],"supposed":[42],"come":[42,82],"generated":[42,53,57,60,69,73,87,90,96,100],"uppercase":[42,49,50],"header":[42,105],"differs":[42],"forbidden":[42],"present":[42,51,81,101,105],"blindcopy":[42],"nodebuild":[42],"generates":[42,103],"modifies":[42],"allowempty":[42],"allow":[42,43,82,92],"scriptbuild":[42],"build":[42,103],"vertexes":[42],"segs":[42],"ssectors":[42],"zdoom_acs":[42],"universalfields":[42],"windows":[42,45,48,53,57,60,69,73,87,90,96,100,102,106],"specifications":[42],"bool":[42,49,50],"radians":[42],"xxrrggbb":[42,48],"enum":[42,48,51,101],"bits":[42,45,48],"byte":[42,48,99],"comment":[42,51,52,58,67,101],"skill6":[42],"class6":[42],"decorategames":[43],"fill":[43],"actors":[43,49,50,51],"who":[43],"raven":[43],"mixtexturesflats":[43],"mixed":[43,68],"priority":[43],"purpose":[43],"scalar":[43],"half":[43],"resolution":[43],"defaultflatscale":[43],"determines":[43],"world":[43],"unscaled":[43],"lists":[43,44,45,46,47],"marker":[43,105],"range":[43,45,48,51,53,57,60,61,69,73,81,87,90,96,100],"pnames":[43],"texture1":[43],"texture2":[43],"zdoom1":[43],"tx_start":[43],"tx_end":[43],"standard1":[43],"standard2":[43],"pp_start":[43],"pp_end":[43],"s_start":[43],"s_end":[43],"f_start":[43],"f_end":[43],"colormaps":[43],"c_start":[43],"c_end":[43],"generalizedsectors":[44],"generalized":[44,45],"makes":[44,45,53,57,60,69,73,87,90,96,100],"gen_sectortypes":[44],"sectorflags":[44],"ceilingportalflags":[44],"portal":[44],"floorportalflags":[44],"sectorrenderstyles":[44],"renderstyles":[44,45,47],"additive":[44,45,47,53,57,60,69,72,73,87,90,96,100],"sectorportalrenderstyles":[44],"portals":[44],"sectorbrightness":[44],"described":[44],"choices":[44,45],"final":[44,45],"sum":[44],"containing":[44],"choice":[44],"secret":[44,45,63,65],"yes":[44],"friction":[44],"wind":[44],"sectortypes":[44],"blinks":[44],"randomly":[44,53,57,60,69,73,87,88,90,96,99,100],"hz":[44],"health":[44],"glows":[44],"sec":[44],"generalizedlinedefs":[45],"gen_linedeftypes":[45],"linedefflags":[45],"bit":[45,48,66],"activation":[45,53,57,60,69,71,73,87,90,96,100],"incorporated":[45],"linedefactivations":[45],"blockmonsters":[45],"twosided":[45],"dontpegtop":[45],"dontpegbottom":[45],"blocksound":[45],"activated":[45],"linedefactivationsfilter":[45],"presses":[45],"projectile":[45],"hits":[45],"bumps":[45],"flies":[45],"mask":[45],"separates":[45],"linedefrenderstyles":[45],"linedefflagstranslation":[45],"translation":[45],"exist":[45],"ot":[45],"correctly":[45,53,57,60,69,73,80,87,90,96,100],"prefabs":[45],"converted":[45,59,99],"equivalent":[45],"prefixed":[45],"inverted":[45,53,57,60,69,72,73,87,90,96,100],"raisable":[45],"existance":[45],"repeatspecial":[45],"playeruse":[45],"monstercross":[45],"impact":[45],"playerpush":[45],"missilecross":[45],"monsteractivate":[45],"conjunction":[45,48,51],"wr":[45],"sr":[45],"gr":[45],"etc":[45,51,53,57,60,69,73,87,90,96,100],"usable":[45],"requiresactivation":[45],"selects":[45,81],"polyobj":[45,48],"sidedefflags":[46],"defaultthingflags":[47],"skill1":[47],"skill2":[47],"skill3":[47],"coop":[47],"thingrenderstyles":[47],"soultrans":[47],"lost":[47],"soul":[47],"translucentstencil":[47],"stencil":[47],"subtract":[47,101],"subtractive":[47,72],"fuzzy":[47],"optfuzzy":[47],"shadow":[47],"r_drawfuzz":[47],"cvar":[47],"info":[47,51,53,57,58,60,69,73,87,90,92,96,100,101,103,104],"nested":[47],"sorted":[47,51],"blue":[47,51,82],"cyan":[47,51],"magenta":[47,51],"brown":[47,51],"pink":[47,51],"orange":[47,51],"renderstyle":[47,48,51],"org":[47,52,101,102,103,104],"actor_properties":[47],"alpha":[47,81],"sprite":[47,51,53,57,60,69,73,87,90,96,100,101],"graphic":[47,51],"fully":[47,51,72,102],"qualified":[47,51],"extension":[47,51],"cposa2":[47,51],"prefixing":[47,51],"width":[47,53,57,60,69,73,87,90,96,100],"hangs":[47],"stuck":[47,51],"fixedsize":[47,51],"rendered":[47,51,53,57,60,69,73,87,90,96,100,104],"sizeless":[47,51],"fixedrotation":[47,51],"absolutez":[47,51],"spritescale":[47],"locksprite":[47],"corresponds":[47],"internally":[47],"attach":[47,101],"inherit":[47,104],"parser":[47,51],"imp":[47,51,101],"trooa2a8":[47,101],"doomimp":[47,101],"flagsrename":[47],"enters":[47,81,82],"secactenter":[47],"activate":[47,75,76,77,84,86],"projectiles":[47],"ambush":[47],"dormant":[47,80],"strifeally":[47],"standing":[47],"tooltip":[48,51],"newline":[48,51],"n":[48,51,53,57,60,61,69,73,87,90,96,100,104],"tooltips":[48,51],"arg1":[48,51,53,57,60,69,73,87,90,96,100],"mirror":[48,84],"polyobject":[48,62,67],"nthis":[48],"movements":[48],"inputs":[48],"radius":[48,51,53,57,60,69,73,87,90,96,100],"targetclasses":[48],"classes":[48,101],"dropdown":[48],"comma":[48,49,50],"arg0":[48,51],"mapspot":[48],"mapspotgravity":[48],"predefined":[48],"volume":[48],"sound_volume":[48],"explicit":[48,51],"enums":[48],"circle":[48,51],"toggled":[48,51,53,55,57,60,62,69,72,73,87,90,96,100],"event":[48,51,53,55,57,60,62,69,73,87,90,96,100],"rendercolor":[48],"hex":[48,51],"ff0000":[48,51],"html":[48,51,53,57,60,69,73,87,90,96,100,103],"formatted":[48,51],"f00":[48,51],"minrange":[48],"minimum":[48,51,99],"indication":[48,51,53,57,60,69,73,87,90,96,100],"minrangecolor":[48],"maxrange":[48],"maxrangecolor":[48],"arg4":[48,51],"anything":[48,102],"raise":[48,53,57,60,69,73,87,90,96,100],"inflict":[48],"crushing":[48],"colorsetter":[48],"provide":[49,50,105],"code":[49,50,53,57,58,59,60,69,73,87,90,96,100,102,103],"completion":[49,50],"paramterets":[49,50],"fs":[49,50],"pt":[49,50],"ps":[49,50],"resultlump":[49,50],"compilation":[49,50],"codepage":[49,50],"scintilla":[49,50],"casesensitive":[49,50],"sensitive":[49,50],"insertcase":[49,50],"int":[49,50],"lowercase":[49,50],"defaullt":[49,50],"lexer":[49,50],"specifies":[49,50,51,53,57,60,69,73,87,90,96,100],"cpp":[49,50],"perl":[49,50],"pascal":[49,50],"insensitive":[49,50,105],"functionopen":[49,50],"brace":[49,50,58],"functionclose":[49,50],"argumentdelimiter":[49,50],"delimiter":[49,50],"terminator":[49,50],"expression":[49,50],"keywordhelp":[49,50],"calling":[49,50],"f1":[49,50,53,57,60,69,73,87,90,96,100],"snippetsdir":[49,50,59],"snippets":[49,50,53,57,59,60,69,73,87,90,96,100],"holds":[49,50],"scripttype":[49,50],"marks":[49,50,51],"recognized":[49,50],"unknown":[49,50,53,57,60,69,73,87,90,96,100],"modeldef":[49,50,53,57,60,69,73,87,90,96,100,101],"sndseq":[49,50,101],"mapinfo":[49,50,53,57,60,69,73,87,90,96,100,101,104],"voxeldef":[49,50,53,57,60,69,73,87,90,96,100,101],"animdefs":[49,50],"reverbs":[49,50,53,57,60,69,73,87,90,96,100,101],"terrain":[49,50,53,57,60,69,73,85,87,90,92,96,100,101],"x11r6rgb":[49,50,101],"cvarinfo":[49,50,101],"lockdefs":[49,50,101],"menudef":[49,50],"sbarinfo":[49,50],"usdf":[49,50,102],"hints":[49,50,53,57,60,69,73,87,90,96,100],"canraiseactor":[49,50],"tid":[49,50],"nchecks":[49,50],"viable":[49,50],"resurrection":[49,50],"nif":[49,50],"activator":[49,50],"constants":[49,50],"aaptr_default":[49,50],"aaptr_friendplayer":[49,50],"aaptr_get_linetarget":[49,50],"aaptr_master":[49,50],"aaptr_null":[49,50],"obtain":[51],"global":[51],"conveyed":[51],"gzdb_skip":[51,101],"stop":[51],"parsing":[51,101,104],"encountering":[51],"speedup":[51],"skipping":[51],"placeable":[51],"declaration":[51,104],"angled":[51],"notangled":[51],"whether":[51,94],"direction":[51,53,57,60,69,73,87,90,96,100],"matters":[51],"represented":[51],"weapons":[51],"identified":[51],"hierarchical":[51],"subgroups":[51],"separator":[51],"tech":[51],"subgroup":[51],"represent":[51],"suitable":[51],"trying":[51],"states":[51],"sequence":[51,101],"inactive":[51],"spawn":[51],"fail":[51],"state":[51],"therefore":[51],"especially":[51],"stateless":[51],"mind":[51],"junka0d0":[51],"junka0":[51],"ignorerenderstyle":[51],"helpful":[51,83],"invisible":[51],"argn":[51],"argndefault":[51],"argntooltip":[51],"argntype":[51],"argnrenderstyle":[51],"argnrendercolor":[51],"argnminrange":[51],"argnminrangecolor":[51],"argnmaxrange":[51],"argnmaxrangecolor":[51],"argnenum":[51],"obsolete":[51],"reason":[51],"idea":[51],"replacing":[51,53,57,60,69,73,87,90,96,100],"standard":[51],"chexshield":[51],"resistancerune":[51],"replaces":[51],"pickups":[51],"powerups":[51],"armxa0":[51],"shield":[51],"strange":[51,52],"powerup":[51],"consider":[51],"else":[51],"respawn":[51],"delay":[51],"arg0tooltip":[51],"positive":[51],"tics":[51],"nnegative":[51],"seconds":[51,92],"arg1tooltip":[51],"config":[51,105],"arg1type":[51],"arg1enum":[51],"arg2":[51],"arg2tooltip":[51],"arg2type":[51],"arg2enum":[51],"arg3":[51],"arg3type":[51],"arg3default":[51],"arg3renderstyle":[51],"arg3rendercolor":[51],"ff00ff":[51],"arg3minrange":[51],"arg3maxrange":[51],"arg3minrangecolor":[51],"0000ff":[51],"arg3maxrangecolor":[51],"arg4type":[51],"arg4default":[51],"inventory":[51],"pickupmessage":[51],"picked":[51,53,57,60,69,73,87,90,93,96,100],"energized":[51],"armor":[51],"armx":[51],"loop":[51,59],"supergiantimpball":[51],"doomimpball":[51],"region":[51],"endregion":[51],"overrides":[51,53,57,60,69,70,73,87,90,96,100,101],"replicate":[51,102,105],"slightly":[51,53,57,60,69,73,87,90,96,100],"balls":[51],"balls0":[51],"sex":[52],"bad":[52],"ultimate":[52],"continuation":[52],"ceased":[52],"development":[52],"udb":[52],"fork":[52,103],"aims":[52],"incorporate":[52],"colored":[52,53,57,60,69,73,87,90,92,96,100],"fog":[52,53,55,57,60,69,73,87,90,96,100],"learn":[52],"mechanics":[52],"illustrated":[52],"guide":[52,103],"http":[52,101,103],"www":[52,101,103],"doombuilder":[52],"com":[52,53,57,60,69,73,79,80,87,90,96,100,103],"doombuilder1guide":[52],"pdf":[52],"table":[52],"deprecated":[52,102],"frequently":[52,104],"asked":[52,104],"questions":[52,104],"generate":[52,85],"shortcuts":[52,53,57,60,69,73,84,87,90,96,100],"author":[52],"english":[52],"my":[52,58,105],"native":[52],"language":[52],"explained":[52],"grammatically":[52],"incorrect":[52],"personal":[52],"message":[52],"forum":[52],"ucp":[52],"php":[52,103],"pm":[52],"compose":[52],"official":[52],"thread":[52],"viewtopic":[52],"misc":[53,57,60,69,73,87,90,96,100],"now":[53,56,57,58,60,65,69,72,73,84,87,88,90,96,100,102,105],"mostly":[53,57,60,69,73,87,90,96,100],"cosmetic":[53,57,60,69,73,87,90,96,100],"downs":[53,57,58,60,69,73,84,87,90,96,100,101],"dbs":[53,57,60,69,73,87,90,96,100],"anyway":[53,57,60,69,73,87,90,96,100],"pasted":[53,57,60,69,73,87,90,96,100],"context":[53,57,60,69,73,87,90,96,100,103],"textboxes":[53,57,60,69,73,87,90,96,100],"nn":[53,57,60,69,73,87,90,96,100,101],"increment":[53,57,60,69,73,75,76,87,90,96,100],"decrement":[53,57,60,69,73,87,90,96,100],"multiply":[53,57,60,69,73,87,90,96,100],"divide":[53,57,60,69,73,87,90,96,100],"incrementally":[53,57,60,69,73,87,90,96,100],"groups":[53,57,60,69,73,82,84,87,90,96,100],"screenshots":[53,57,60,69,73,87,90,96,100],"screenshot":[53,57,60,69,73,87,90,96,100],"f12":[53,57,60,69,73,87,90,96,100],"commands":[53,57,60,69,73,87,90,96,100],"export":[53,57,60,69,73,85,87,90,96,100],"via":[53,57,60,69,73,87,90,96,100],"wavefront":[53,57,60,69,73,85,87,90,96,100],"obj":[53,57,60,69,73,85,87,90,96,100],"whole":[53,57,60,69,73,80,82,87,90,96,100],"previews":[53,57,60,69,73,87,90,96,100],"unchecking":[53,57,60,69,73,87,90,96,100],"sizes":[53,57,60,69,73,87,90,96,100],"per":[53,56,57,60,69,73,87,90,96,100],"hiding":[53,57,60,69,73,87,90,96,100],"filtered":[53,57,60,69,73,87,90,96,100],"indicator":[53,57,60,69,73,87,90,96,100],"corner":[53,57,60,69,73,75,87,90,96,100],"enhanced":[53,55,57,58,60,61,69,72,73,87,90,96,100],"workflow":[53,57,58,60,69,73,87,90,96,100],"bcc":[53,57,60,69,73,87,90,96,100],"https":[53,57,60,69,73,79,80,87,90,96,100,103],"github":[53,57,60,69,73,79,80,87,90,96,100,103],"wormt":[53,57,60,69,73,87,90,96,100],"bundled":[53,57,60,69,73,87,90,96,100],"synchronized":[53,57,60,69,73,87,90,96,100],"picker":[53,57,60,66,69,73,87,90,96,100],"tint":[53,57,60,69,73,81,87,90,96,100],"explorer":[53,57,60,61,67,69,73,87,90,96,100,103],"randomized":[53,57,60,69,73,87,90,96,100],"transformations":[53,57,60,69,73,87,90,96,100],"folder":[53,57,59,60,68,69,73,87,90,96,100,101,102,103,104],"realtime":[53,57,60,69,73,87,90,96,100],"rotation":[53,57,60,69,73,87,90,96,100],"appropriate":[53,55,57,60,69,73,87,90,96,100,101],"random":[53,57,60,69,73,83,87,90,96,99,100],"panels":[53,57,60,69,73,87,90,96,100],"assign":[53,57,58,60,61,69,73,82,87,90,96,100],"rectangular":[53,57,60,69,72,73,87,90,96,100],"go":[53,57,60,65,69,73,87,90,96,100],"ui":[53,57,60,69,73,81,82,87,90,96,100],"paint":[53,57,60,69,72,73,87,90,96,100],"ellipse":[53,57,60,69,73,76,87,90,96,100],"importer":[53,57,60,69,73,85,87,90,92,96,100],"bridge":[53,57,60,69,73,84,87,90,96,100],"alt":[53,57,60,69,72,73,76,77,87,90,94,96,100],"initial":[53,57,60,69,73,87,90,94,96,100],"statistics":[53,57,60,61,69,73,87,90,96,100,102],"overlaps":[53,57,60,69,70,73,87,90,96,100],"touches":[53,57,60,69,70,73,87,90,96,100],"brighntess":[53,57,60,69,70,73,87,90,96,100],"touch":[53,57,60,69,73,87,90,96,100],"length":[53,57,60,69,73,87,90,96,100],"pinned":[53,57,60,69,73,87,90,96,100],"slopes":[53,57,60,69,71,73,82,87,90,93,96,100],"deletion":[53,57,60,69,73,87,90,96,100],"syncronized":[53,57,60,69,72,73,87,90,96,100],"de":[53,57,60,69,72,73,87,90,96,100],"overlay":[53,57,60,69,73,87,90,96,100],"fade":[53,57,60,66,69,73,87,90,96,100,101],"try":[53,57,60,69,73,87,90,96,100],"transform":[53,57,60,69,73,83,87,90,96,100],"total":[53,57,60,69,73,87,90,96,100],"surface":[53,57,60,66,69,73,87,90,94,96,100],"clone":[53,57,60,69,73,87,90,96,100,103],"starting":[53,57,60,61,69,73,87,90,96,100],"merging":[53,57,60,69,73,87,90,96,100],"animation":[53,57,60,69,73,87,90,96,100],"patrolpoints":[53,57,60,69,73,87,90,96,100],"cameras":[53,57,60,69,73,87,90,96,100],"interpolationpoints":[53,57,60,69,73,87,90,96,100],"plane":[53,57,60,69,73,82,87,90,93,96,100],"translucency":[53,57,60,69,73,87,90,96,100,101],"ignore":[53,57,60,64,69,73,87,90,96,100,103],"shading":[53,57,60,69,73,87,90,96,100],"going":[53,57,60,61,64,69,73,84,87,90,96,100],"west":[53,57,60,69,73,87,90,96,100],"east":[53,57,60,69,73,87,90,96,100],"darker":[53,57,60,69,73,87,90,96,100],"north":[53,57,60,69,73,87,90,96,100],"south":[53,57,60,69,73,87,90,96,100],"affected":[53,57,60,69,72,73,80,87,90,96,100],"vertwallshade":[53,57,60,69,73,87,90,96,100,101],"horizwallshade":[53,57,60,69,73,87,90,96,100,101],"evenlighting":[53,57,60,69,73,87,90,96,100,101,104],"smoothlighting":[53,57,60,69,73,87,90,96,100,101,104],"zfloor":[53,57,60,69,73,85,87,90,92,96,100],"zceiling":[53,57,60,69,73,87,90,92,96,100],"wheel":[53,57,60,69,73,87,90,96,100],"transfer":[53,57,60,69,73,87,90,96,100],"lock":[53,57,60,69,73,78,87,90,96,100,101],"movement":[53,57,60,69,73,84,87,90,96,100],"horizontal":[53,57,60,69,73,78,87,90,93,96,100],"axis":[53,57,60,69,73,85,87,90,96,100],"peg":[53,57,60,69,73,87,90,96,100],"rest":[53,57,60,69,73,87,90,96,100],"affect":[53,57,60,69,73,87,90,96,100],"pagedown":[53,57,60,69,73,87,90,96,100],"pageup":[53,57,60,69,73,87,90,96,100],"higher":[53,57,60,69,73,87,90,96,100],"lowest":[53,57,60,69,73,84,87,90,96,100],"ground":[53,57,60,69,73,87,90,96,100],"num9":[53,57,60,69,73,87,90,96,100],"num7":[53,57,60,69,73,87,90,96,100],"num6":[53,57,60,69,73,87,90,96,100],"num4":[53,57,60,69,73,87,90,96,100],"num8":[53,57,60,69,73,87,90,96,100],"num5":[53,57,60,69,73,87,90,96,100],"fit":[53,57,60,69,73,87,90,94,96,100],"slope":[53,57,60,69,73,81,82,85,87,90,93,96,100],"call":[53,57,60,69,73,87,90,96,100],"rotates":[53,57,60,69,73,87,90,96,100],"handling":[53,57,60,69,73,87,90,96,100],"aimingcamera":[53,57,60,69,73,87,90,96,100],"movingcamera":[53,57,60,69,73,87,90,96,100],"securitycamera":[53,57,60,69,73,87,90,96,100],"interpolationpoint":[53,57,60,69,73,87,90,96,100],"counterclockwise":[53,57,60,69,73,76,87,90,96,100],"pitch":[53,57,60,69,73,87,90,96,100],"roll":[53,57,60,69,73,87,90,96,100],"cut":[53,57,60,69,73,87,90,96,100],"taken":[53,57,60,69,73,87,90,96,100],"local":[53,57,60,69,73,87,90,96,100],"hidden":[53,57,60,69,73,87,90,96,100],"individually":[53,57,60,69,73,87,90,96,100],"unconnected":[53,57,60,69,73,87,90,96,100],"overlapping":[53,57,60,69,73,87,90,96,100],"positions":[53,57,60,69,73,87,90,96,100],"invalid":[53,57,60,69,73,87,90,96,100],"unused":[53,57,60,61,69,73,87,90,96,100],"missing":[53,57,60,69,73,87,90,96,100,103],"viewer":[53,57,60,69,73,87,90,96,100,106],"znodes":[53,57,60,69,73,87,90,96,100],"xnod":[53,57,60,69,73,87,90,96,100],"xgln":[53,57,60,69,73,87,90,96,100],"xgl2":[53,57,60,69,73,87,90,96,100],"xgl3":[53,57,60,69,73,87,90,96,100],"md2":[53,57,60,69,73,87,90,96,100],"md3":[53,57,60,69,73,87,90,96,100],"voxledef":[53,57,60,69,73,87,90,96,100],"partial":[53,57,60,69,73,87,90,96,100],"doomednum":[53,57,60,69,73,87,90,96,100,101,104],"spawnnums":[53,57,60,69,73,87,90,96,100,101],"directives":[53,57,60,69,73,87,90,96,100],"compiled":[53,57,58,60,69,73,87,90,96,100],"png":[53,57,60,69,73,87,90,96,100],"pcx":[53,57,60,69,73,87,90,96,100],"archive":[53,57,60,69,73,87,90,96,100,103],"toggles":[55],"pseudo":[58],"updated":[58],"successfully":[58],"regular":[58,72],"selector":[58,61],"reusable":[59],"snippet":[59],"alternatively":[59,103],"expand":[59],"tokens":[59],"ep":[59],"entry":[59],"inserting":[59],"lb":[59],"breaks":[59],"allman":[59],"bracing":[59],"located":[59,103,105],"ve":[59,65],"vs":[61],"expects":[61],"pressed":[61],"relatively":[61],"ranges":[61,81],"entering":[61,81],"being":[61,82],"functionality":[61,102],"labels":[61],"label":[61],"column":[61,95],"cells":[61],"columns":[61,95],"sortable":[61],"autocompletion":[61],"typing":[61],"sort":[61],"happen":[62],"arrows":[62],"targets":[62],"patrol":[62],"points":[62],"interpolation":[62,84],"corresponding":[62,66],"spots":[62],"anchors":[62],"let":[63,65,81,82,84,88,95],"say":[63,65,82,84,88,95],"inspect":[63,65],"f9":[63],"synchronizing":[64,65],"retain":[64],"q":[64,65,104],"invert":[64],"synchronize":[64,65],"unlike":[65],"entirely":[65],"leaving":[65],"centered":[65],"temporarily":[65],"synchronization":[65],"lightcolor":[66],"fadecolor":[66],"belongs":[66],"usage":[67,84,85,105],"horizon":[67],"displays":[68],"allowing":[68],"technical":[68,71,92,99],"texures":[70],"evaluated":[71],"preset":[71],"never":[71],"started":[72,105],"surrounded":[72],"intersect":[72],"marquee":[72],"indicated":[72,82],"outline":[72],"touching":[72],"partially":[72],"subdivision":[75,76,77,78,84],"bevel":[75,76,78],"continuous":[75,76,77,78,94],"finishing":[75,76,77,78],"amount":[75],"detail":[75],"negative":[75],"ellipsoid":[76],"finish":[77,82],"detailed":[77],"grids":[78],"slices":[78],"directions":[78],"triangulate":[78],"triangles":[78],"quads":[78],"propagation":[79,80],"boris":[79,80],"iwanski":[79,80],"biwa":[79,80],"soundpropagationmode":[79,80],"propagates":[79],"interaction":[79,80],"travel":[79],"unhindered":[79],"environments":[80,83],"supplies":[80],"docker":[80,81],"soundenvironment":[80],"belonging":[80],"zone":[80],"behaviors":[80],"probably":[80,101],"did":[80],"intend":[80],"sign":[80],"bubble":[80],"collapsed":[80],"soundenivornment":[80],"latter":[80],"caused":[80],"unintentionally":[80],"bleeding":[80],"sealed":[80],"manage":[81],"cycle":[81],"cycles":[81],"relocate":[81],"relocates":[81],"upon":[81],"csa":[81],"able":[81],"modifying":[81,82],"resizing":[81],"pointing":[81],"define":[81,82,84],"desired":[81,105],"managing":[81],"similar":[81,82],"deselect":[81],"widget":[81],"bar":[81,82],"thickness":[81],"calculated":[81],"commonly":[81],"workflows":[81],"duplicate":[81],"detach":[81],"remocing":[81],"adding":[81,101,104],"unchecks":[81],"removing":[81],"comes":[81,103],"sure":[81,103],"dockers":[81],"expanded":[81],"necessary":[81],"svg":[82],"primary":[82],"sloping":[82],"lope":[82],"finishes":[82],"needs":[82,101],"undo":[82],"redo":[82],"sessions":[82],"asking":[82],"easiest":[82],"three":[82],"forming":[82],"anywhere":[82],"repeat":[82],"third":[82],"understand":[82],"handy":[82],"assigning":[82,88],"wile":[82],"depicting":[82],"fc":[82],"sloped":[82,85],"multi":[82,106],"simultaneously":[82],"hovering":[82],"notably":[82],"having":[82],"sections":[82],"hover":[82],"randomize":[83],"randomness":[83],"kind":[83],"natural":[83],"caves":[83],"distorted":[83],"hell":[83],"update":[83,101],"connect":[84],"bezier":[84],"handle":[84],"tool":[84],"esc":[84],"interpolated":[84],"subdivisions":[84],"paired":[84],"itself":[84],"easeinsine":[84],"interpolates":[84],"sinusoidal":[84],"sin":[84],"easing":[84],"easeoutsine":[84],"easeinoutsine":[84],"stairway":[84],"lots":[84],"hand":[84],"pair":[84],"import":[85],"favorite":[85],"modeling":[85],"app":[85],"blender":[85],"earth":[85],"sculptor":[85],"transformed":[85],"self":[85],"explanatory":[85],"averaged":[85],"limitations":[85],"triangulated":[85],"polygons":[85],"viewed":[85],"slaughterwad":[88],"vatiety":[88],"orient":[89],"face":[89],"triangular":[92],"took":[92],"approx":[92],"wonderous":[92],"elaborate":[92],"terrains":[92],"closest":[93],"sharing":[94],"threated":[94],"unselected":[95],"room":[95],"picks":[99],"min":[99],"virtual":[99],"user_test":[99],"poulate":[101],"extra":[101],"abort":[101],"flipx":[101],"flipy":[101],"blend":[101],"styles":[101],"modulate":[101],"reversesubtract":[101],"old":[101,105],"spawnthing":[101],"outsidefog":[101],"fogdensity":[101],"outsidefogdensity":[101],"ambient":[101],"titles":[101],"populate":[101],"ambient_sounds":[101],"body":[101],"parsers":[101],"cvars":[101],"distancecheck":[101],"translations":[101],"glowing":[101],"brightmaps":[101],"future":[101],"since":[101],"aren":[101],"configs":[101],"came":[101],"shipped":[102],"versions":[102,106],"longer":[102],"newer":[102,103,106],"gzdoomediting":[102],"dll":[102],"merged":[102],"buildermodes":[102],"crash":[102,105],"startup":[102],"core":[102,103,106],"udmfcontrols":[102],"copypastesectorprops":[102],"unfinished":[102],"ship":[102],"imagedrawingexample":[102],"people":[102],"interested":[102],"universal":[102],"wadauthormode":[102],"aimed":[102],"wadauthor":[102],"express":[103],"edition":[103],"net":[103,106],"framework":[103,106],"download":[103],"free":[103],"msdn":[103],"microsoft":[103,106],"vstudio":[103],"studio":[103],"client":[103],"scm":[103],"tortoisegit":[103],"archiver":[103],"inno":[103],"jrsoftware":[103],"isinfo":[103],"en":[103],"details":[103],"aspx":[103],"slimdx":[103],"developer":[103],"sdk":[103],"directx":[103,106],"obtaining":[103],"hosted":[103],"quick":[103],"assumes":[103],"tortiosegit":[103],"wait":[103],"sln":[103],"compiles":[103],"runs":[103],"play":[103],"complains":[103],"re":[103],"references":[103],"solution":[103],"x86":[103,106],"jetbrains":[103],"profiler":[103],"api":[103],"everything":[103],"dottrace":[103],"planning":[103],"submit":[103],"repository":[103],"recomeded":[103],"pull":[103],"request":[103],"batch":[103,105],"compile":[103],"package":[103,106],"launching":[103],"variables":[103],"clean":[103],"rebuild":[103],"bat":[103],"cache":[103],"release":[103],"refmanual":[103],"chm":[103],"latest":[103],"revision":[103],"changelog":[103],"txt":[103],"installer":[103,106],"commits":[103],"master":[103],"branch":[103],"packs":[103],"git_build":[103],"getting":[104],"ton":[104],"unable":[104],"wrong":[104],"happens":[104],"inherited":[104],"forget":[104],"exclude":[104,105],"chekbox":[104],"zandronum":[104],"skulltag":[104],"skulltag_actors":[104],"skulltag_data":[104],"rid":[104],"fake":[104],"contrast":[104],"fake_contrast":[104],"emulates":[104],"defaultmap":[104],"gzbuilder":[105],"wadfile":[105],"mapname":[105],"configname":[105],"delaywindow":[105],"nosettings":[105],"strictpatches":[105],"portable":[105],"dir":[105],"roottextures":[105],"rootflats":[105],"notest":[105],"resourcename":[105],"e1m1":[105],"skip":[105],"delays":[105],"showing":[105],"completed":[105],"terminating":[105],"yet":[105],"usefull":[105],"processes":[105],"completes":[105],"terminates":[105],"application":[105],"lose":[105],"launched":[105],"localappdata":[105],"log":[105],"report":[105],"enforce":[105],"adhere":[105],"rule":[105],"game_configuration":[105],"subfolder":[105],"strict":[105],"loads":[105],"ubermegawad":[105],"initialized":[105],"doom_doom2doom":[105],"gzdoom_doomudmf":[105],"gothtextures":[105],"hardmonsters":[105],"requirements":[106],"ghz":[106],"cpu":[106],"xp":[106],"vista":[106],"graphics":[106],"card":[106],"sp1":[106],"redistributable":[106],"later":[106],"install":[106],"backwards":[106],"runtime":[106],"components":[106]}};

function search(searchString) {
	var words = searchString.split(/\W+/);
	if (words.length > 0 && words[words.length-1] == "") words.splice(-1);
	if (words.length == 0) return [];

	var results = {};
	var totalWords = 1;
	var lastword = words.splice(-1)[0].toLowerCase();

	// Search whole word results for everything except last word
	words.forEach(word => {
		if (word != "") {
			var key = word.toLowerCase();
			if (searchIndex.keys[key] != undefined) {
				searchIndex.keys[key].forEach(x => {
					if (results[x] == undefined) results[x] = 1;
					else results[x]++;
				});
			}
			totalWords++;
		}
	});

	// Partial word search for the last word
	Object.keys(searchIndex.keys).forEach(key => {
		if (key.length >= lastword.length && key.substr(0, lastword.length) == lastword) {
			searchIndex.keys[key].forEach(x => {
				if (totalWords == 1 || results[x] == totalWords - 1) results[x] = totalWords;
			});
		}
	});

	// Only match pages that included all the words
	var output = [];
	Object.keys(results).forEach(x => { if (results[x] == totalWords) output.push(searchIndex.items[x]) });
	output.sort((a, b) => a.name.localeCompare(b.name));
	return output;
}

function generateIndex() {
	function addItems(list, output) {
		list.forEach(x => {
			output.push(x);
			if (x.items != undefined) addItems(x.items, output);
		});
		return output;
	}
	var items = addItems(contents, []);
	var curIndex = 0;
	
	searchIndex = {
		items: items.map(x => { return { name: x.name, src: x.src } }),
		keys: {}
	};
	
	var timeoutID;
	
	function done() {
		content.removeEventListener('load', contentLoaded);
		content.removeAttribute("src");
		
		content.setAttribute("srcdoc", JSON.stringify(searchIndex));
	}
	
	function next() {
		curIndex++;
		if (curIndex < items.length) {
			timeoutID = setTimeout(contentFailedLoad, 2000);
			content.setAttribute("src", items[curIndex].src);
		}
		else {
			done();
		}
	}
	
	function contentFailedLoad() {
		// console.debug("Failed to load " + items[curIndex].name + " (" + items[curIndex].src + ")");
		next();
	}

	function contentLoaded(event) {
		clearTimeout(timeoutID);

		if (content.contentDocument == null) {
			content.removeEventListener('load', contentLoaded);
			alert("security.fileuri.strict_origin_policy needs to be enabled for generateIndex() to work (remember to turn it off again after!)");
			return;
		}
		
		var wordSet = {};
		content.contentDocument.body.innerText.split(/\W+/).forEach(word => {
			if (word != "") wordSet[word.toLowerCase()] = true;
		});
		
		Object.keys(wordSet).forEach(word => {
			if (searchIndex.keys[word] == undefined) searchIndex.keys[word] = [];
			searchIndex.keys[word].push(curIndex);
		});

		next();
	}
	timeoutID = setTimeout(contentFailedLoad, 2000);
	content.addEventListener('load', contentLoaded);
	content.setAttribute("src", items[curIndex].src);
}

function addClass(element, name) {
	var classes = getClasses(element);
	var index = classes.indexOf(name);
	if (index == -1) {
		classes.push(name);
		setClasses(element, classes);
	}
}

function removeClass(element, name) {
	var classes = getClasses(element);
	var index = classes.indexOf(name);
	if (index != -1) {
		classes.splice(index, 1);
		setClasses(element, classes);
	}
}

function getClasses(element) {
	var classes = element.getAttribute("class");
	if (classes == null) return [];
	return classes.split(" ");
}

function setClasses(element, classes) {
	element.setAttribute("class", classes.join(" "));
}

function filterItems(filter) {
	while (listview.lastChild != null) {
		listview.removeChild(listview.lastChild);
	}
	listviewItems = [];
	
	if (filter == "") {
		contents.forEach(item => addItem(listview, item, 1));
	}
	else {
		search(filter).forEach(item => addItem(listview, item, 1));
	}
}

function itemSelected(element, item) {
	listviewItems.forEach(x => removeClass(x, "selected"));
	addClass(element, "selected");
	content.setAttribute("src", item.src);
}

function addItem(parent, item, level) {
	var element = document.createElement("div");
	var text = document.createElement("div");
	addClass(element, "listviewitem");
	addClass(text, "listviewitem-text");
	text.style.paddingLeft = (level * 20) + "px";
	text.innerText = item.name;
	text.addEventListener('click', event => itemSelected(element, item, event) );
	element.appendChild(text);
	listviewItems.push(element);
	parent.appendChild(element);
	if (item.items != undefined) {
		item.items.forEach(childitem => addItem(element, childitem, level + 1));
	}
}

searchbox.addEventListener('input', event => filterItems(searchbox.value, event));
contents.forEach(item => addItem(listview, item, 1));
